Introduction

 Top Next

Find and Run Robot

Version 2.90.01 - Aug 18, 2010

For Microsoft Windows XP/VISTA/NT/2000/9x/ME.

Works hard to make you go faster

NEW: Learn about the default alias commands and how to make your own!

NEW: Learn about the new directory searching functions in Version 2!

NEW: Learn about the new keyword modifiers in Version 2!

Find and Run Robot is a program for keyboard maniacs - it helps you rapidly find programs or documents from within the depths of the start menu (or other directories).

One keypress launches the utility - then just start typing the the name of the application you want to run. When it appears in the result box, press the number associated with the app to launch it.

Features:

· fully customizable search paths (search your entire hard disk for files as well as apps)
· fast incremental searches, with memorized search history helps you find the files you need quickly.
· completely customizable heuristic scoring metrics - tune the program to search the way you think.
· low system overhead, doesn't mess with your registry.
· unobtrusive and stays out of your way until you need it.


Some Default Alias Commands

 Top Previous Next

Starting with version 1.09.01 Find and Run Robot comes with some default alias commands you can use.

Just type the alias name and then any optional arguments and select your choice from the menu (or hit enter for default item).

Remember you can add your own group aliaes and customize existing ones from the options page!

· dc - search the donationcoder.com forum
· run - run a command on the windows path
· email - start an email with default client
· imdb - perform an internet search at the imdb website
· paste - paste common info like date
· www - visit a website
· calc - calculate a numeric expression (thanks to FBSL Freestyle Basic Script Language, http://www.fbsl.net/phpbb2/index.php)
· cmd - execute a nircmd command (requires separate install of freeware http://www.nirsoft.net/utils/nircmd.html)
· define - search an online dictionary
· search - do a web search with google pages, etc.
· music - search for info on a band, etc.


Installation

To install Super Happy Find and Run Robot, simply run the installatin program provided.

You can install new versions of this program over existing programs, and you can uninstall the program easily from your start menu.

Find and Run Robot keeps all of its settings in an ini file in its local directory - it does not mess with your registry.

It does not install any system files or in any way interefere with your existing files.

What is Installed?

There are two executable files that are installed with the program. The main executable, FindAndRunRobot.exe, and a tiny systemtray helper utility, FindAndRunRobotSystemTrayTrigger.exe.

The helper utility, if run, will sit in your system tray, and allow you to access Find and Run robot easily. When loaded, pressing the pause/break key on your keyboard will activate the program. Pressing it again will close it. You can also double-click on the system tray icon to toggle the program on and off.

You can unload the helper utility at any time, by right-clicking on it's icon.

The system tray helper utility is under 50k and was designed to take up minimal resources and clock cycles

Super Happy Find and Run Robot was originally designed to start each time you start windows (the helper util is the only thing that stays resident), so that you could quickly launch the program when you need it.

However, in order to be polite, the program will not install itself to start up with windows unless you specifically ask it to. Just start the program and check the box labeled "start when windows starts." If you change your mind at a later date, simply run the program and uncheck this box.

If you already have another hotkey program you wish to use instead of the helper utility we provide, or if you want to run the program through an exisiting application launcher, that's fine, the main program can be launched from any 3rd party launcher, and will not stay resident when it is exited.

NOTE: If you choose not to install the start menu group shortcuts, and want to launch the program and have it stay resident in the tray, call it with the -tray commandline parameter.


Basic Usage

When the program is started for the first time (or if it finds itself missing a configuration file), Super Happy Find and Run Robot will initialize itself with default values which should work well for you with no modification.

First, check your system tray (the string of icons on the bottom right of your screen to the left of your system clock). If you do not see a little man in a blue circle, then the Super Happy Find and Run Robot Hotkey Tray Utility is not currently running - start it from the Start Menu. If you decide that you like this utility you can configure it to start with Windows from its main Options page.

Basic Use:

1. Press the Pause/Break key on the upper right of your keyboard to start Super Happy Find and Run Robot.
2. Start typing the name of the application you want to run.
3. As you type, you'll see the results of an ongoing search through your start menu (or other directories you have marked for search).
4. The top best guesses for what you are looking for are shown in the list. You can at anytime revise your search, there's no need to wait for the seach to complete.
5. If and when you see the application you are looking for, press the key associated with that application to launch it, closing Super Happy Find and Run Robot in the process.


Creating Your First Alias

Let's say you have a particular file or application that you want to be able to refer to by a shorthand nickame or alias, and you want it to come up instantly in results. For this you want to create an alias.

Aliases can do very complicated things, but this is the simplest kind of thing you can do, and will be a good first introduction to creating your own aliases.

Try this as the easiest way to add a new alias for a file:

· Drag and drop any file or program from any other program into the Search Edit Box of FARR, to have it show up in results.
· OR simply search for the file or program inside FARR until it shows up in results.
· Then, right click on this result to select it, and choose the menu "Add to Group Alias". Then choose the last menu item labeled "New Alias Group.."
· Then in the dialog that appears, just type in the short name you want to use as an alias for this file in the "Group Alias Name" box, and click the Ok button, leaving the other options at their defaults.
· All done. Anytime you want to find this file just type its short name (alias).


Searching in Specific Directories

Basic Searching in Specific Directories

New in Find+Run Robot v2

You can now tell FARR where to look for files and folders by providing a full (or partial) directory path in your search query,

Normally when you use FARR you just type in some letters from the name of a program you want to launch which is located on your start menu.

However, sometimes you may want to locate a file or a directory which may be located someplace else on your hard drive that you don't have configured on your normal search paths.

Or alternatively, you may want to use FARR as a kind of incremental auto-completing file browser (or dos Run box replacement).

To use this new functionality in FARR v2, just start typing the directory you want to search, like:

C:\Program Files\

As you type, FARR will begin to show you matching directories and files.

Note that you don't have to type out the full directory names, just enough to help FARR disambiguate between the possibilities, but by using full directories FARR will be able to search faster as it has less possibilities to consider.


Advanced Directory Searching

FARR v2 supports the ability to type in explicit paths in your search query.

When you type in such a path, the results window will show files and folders in that path.

It's not unusual to have too many files and folders to display, in which case you may want to use a few tricks to help narrow down the results.

Use a period (.) at the end of the path to show only files in the directory and no subfolders.

e.g. C:\Windows\. (will show only files in the windows directory, no folders)

You can also type a pattern after the . to further limit results:

e.g. C:\Windows\.sys (will show only files in the windows directory with the word sys in them)

Use a double forward slash (\\) at the end of the path to show only subfolders and not files.

e.g. C:\Windows\\ (will show only subfolders within the windows directory)

You can also use simple wildcards.

e.g. C:\Windows\*.bpl


Non-specific Directory Searching

If you do not specify a root directory, but you use the \ character, then your normal search directories will be searched for matching subdirectories anywhere in the paths. For example if you type:

accessories\notepad

Then by default FARR will search for files and folders matching with the word 'notepad' in them, which are derived from some parent path with the word 'accessories' in it (not nesc. the immediate parent). The only drawback to such searches is that they can be slow.

And remember you dont have to use full words, you could just as easily type:

acc\not


Directory Searching Tricks

One key to fast and efficient directory searching is to use some keyboard shortcuts (don't look so surprised!).

If you hit the tab key while typing and a subdirectory is shown at the top of the results list (first result), that path will be added to your current search string. This is similar to the "autocomplete" function found in many programs.

You can also achieve the same result by hitting ALT+RIGHT ARROW.

If you hit the ALT+LEFT ARROW or ALT+BACKSPACE, the last subdirectory on your search path will be removed, bringing you back up one directory.

You are not limited to autocompleting based only on the first path in the result list. You can also use alt+# to specifically change to the specific result directory by index number.

You can normally just hit enter to open the the first item in the results list,so if you want to open the path you have typed in the search bar, make sure you leave off the last \, or use the ALT+ENTER hotkey to explicitly open the path in the search string.

You can use \\ in the middle of a path to tell FARR to match any single directory.

Use \*\ to match multiple directories greedily.


Main Options

Once you get used to the way Find and Run works, you'll want to tweak it to do the best job of finding the files you use.

From the Options dialog you can add a variety of rules and adjust the scores of existing rules.

On each page with a list of rules, use the right-click of your mouse to edit/delete/add rules, or drag items to re-order them.

Main Configuration

Digit keys - Digit keys can be used to rapidly execute from result list. The top 9 search results are prefaced by a number; simply press a # to launch the corresponding entry. Note that checking this opions means that you cannot easily use digits in your searches if you also enable the Incremental Search option (You can use # to precede a digit in a filename even when you've got the "Digit Keys Launch Results" option checked, or else configure FARR to let you use Ctrl or Alt to type in digits). If you disable this option you can still use the function keys to launch results, or tab to the results window and then use the digit keys.

Start with top files - Enabling this option will cause the results window to show the top entries from your Launch History list, giving you fast access to recently launched files. Files with scores less than 0 will not be added to the list of top files on startup.

Incremental search - With this option enabled, as you type each letter of the search string, searching will take place simultaneously. You can keep typing and narrowing the search, or stop when your program appears. If this option is disabled, hit enter to search for the current search string.

Show serch subdir details - This options shows each sub-directory in the status bar as it it being searched. This can be useful to find where the program is spending most of its time searching, but it does slow down searching and so should normally be disabled.

Remove duplicate links - This option tells the program not to show two different shortcuts to the same applications.

Start with windows - Checking this option will insert an entry into your Start Menu->Startup section, causing the Find and Run Robot Tray Utility to start automatically with windows, so you can use the pause/break key to trigger the program. Unchecking this option will remove the startup immediately. You can uncheck and check this as much as you want, it wont make duplicate entries or damage your system.

User Helper Tray Utility - Starting with version 1.04.00, there are two different ways to have Find and Run Robot startup and run in the background until you need it. You can use a very small dll utility which runs in the tray and is responsible for launching the main program when it detects the 'Break' hotkey has been pressed. This utility is a very small .exe and .dll and uses very little system resources. However, when using it you may notice annoying delays (1-3 seconds) between pressing the hotkey and launching the program. As an alternative, you can now uncheck the "use helper tray utility" checkbox, which will cause the main application itself to load an hide in the tray until you hit the 'break' hotkey. This option will use more of your system memory, BUT should result in instantaneous launching of the program. The later method is the recommended option if you use Find and Run Robot on a regular basis.

Max entries - Sets the number of top matching files displayed during searches. Normally a value of 9 is sufficient - large numbers may slow down the sorting of large numbres of results when searching on very short search strings, so you might not want to just max this out.

Max files - Limit the number of executed files added to Launch History list for fast search and initial launch.

Results style - Display mode for results.

· small icons:

· large icons:

· detailed repoort:

The detailed report view shows the calculated score for each entry, which can be helpful if you are trying to figure out why one entry is being scored above another. The locatoin info displayed is based on the Result path option. If the Results Extension option is enabled, the Type column will be used to display alternate windows information about the file type.

Results extension - Include file extensions in results window.

Result path - What path information to display in the label of each result. This information can help indicate where the file was found, if the filename is not sufficient. For example, if the file found was C:\WINDOWS\Start Menu\Programs\Applications, Editors\UltraEdit\UltraEdit-32 Text Editor.lnk

· none: [no path will be displayed except in detailed report view].
· one level back: UltraEdit\UltraEdit-32 Text Editor.lnk
· two levels back:Applications, Editors\UltraEdit\UltraEdit-32 Text Editor.lnk
· relative to search: Applications, Editors\UltraEdit\UltraEdit-32 Text Editor.lnk [based on folder being searched]
· full path:C:\WINDOWS\Start Menu\Programs\Applications, Editors\UltraEdit\UltraEdit-32 Text Editor.lnk


Heuristic Scoring

Find and Run Robot is different from other search engines in that when multiple files match your search string, Find and Run Robot tries to figure out which files you are most likely to be interested in, and puts those at the top of a sorted list. It does this by scoring each result using a number of adjustable rules.

The heuristic scoring tab shows rules-of-thumb for scoring results, to help give higher scores to results that are likely to be most useful to you. You can disable any rule by unchecking it. Order is unimportant.

· History File Bonus: These are the points awarded by default to files added to the Launch History list when they are added after you launch them (you can customize the points awarded to specific files in the Launch History window). This setting therefore only has an indirect result, if you make this value low, you are saying that new programs added to the Launch History list will not be given much priority over other results.
· Extact Match Bonus: This is a bonus given to a result if the filename (minus extension and path) match the search string exactly as you have typed it.
· Leftmost Match Bonus: This is a bonus given to any result where the search string matches the begining characters of the result, useful because most of the time you are typing in the first few letters of the file you are searching for.
· Percentage of Search String Points: These are points given to reward shorter names over longer names; can be very useful at weeding out helper files for a main file. an exact match would receive the points listed; if length of found file was twice size of search string, than half of these points would be awarded to it.
· Whitespace Removal Penalty: Sometimes files names have spaces in them, sometimes they don't. Often you can't remember if the file is "Photoshop" or "Photo Shop." To help you, Find and Run Robot asks that you type "photo shop", and then it will automatically look for both what you type, and also a version with no spaces ("photoshop"). Thes points specified indicate the added score (or cost if negative) for files that match the second case when spaces were removed.

Like all rules, you can right click on one and adjust the score associated with that rule.


Pattern Scoring

The Patten Scoring rules allow you to specify additional points awarded based on file or folder patterns. These patterns are check against the full filename (including path and extension) of each result. Using these patterns you can penalize certain file types, like backup files (*.bak) or certain directories (C:\Windows\Backup\*).

You right click to add, edit, or delete rules. You can also add a pattern based on a found result in the main window, by right-clicking on that result. This can be useful if bad results are found and you want to quickly set up a pattern to lower their scores in the future.


Search Folders

Search folders specify:

· Where Find and Run Robot should search.
· What order to search in.
· How many bonus points are awarded to files in each directory.

Search order is important. The start menu is relatively small compared to your Program Files directory, so you will probably want to start searching in the Start Menu. You can re-arrange search order by simply dragging directories to their new locations.

When Find and Run Robot starts for the first time, it will initialize this list with some default directories based on your system. You can check and uncheck entried to disable them, or add/edit/delete using the right-click menu.

TIP: To add folders to be searched in a quick way, open up Windows Explorer or any file manage, and simply drag and drop folders onto this window.

Search Depth:

-1 = search all (ie goes as deep as exists)

0 = search no subdirectories

1 = search 1 level deep

2 = search 2 levels deep

etc.


Launch History

The Launch History window contains a list of previously launched files. This list serves three purposes.

· First, it is always searched first during matching and scoring, so that any program in this list will be found instantly as you type a matching search string. This can be very useful for repeated locating of files.

· Second, it allows you to assign bonus points (or penalties) to specific files. This can be helpful in order to either prevent a file from being listed in search results, or to bring it to the top.

· Third, this list can be displayed (see Main Options) in the initial results window when Find and Run robot starts, providing a kind of quick list of files to launch prior to any search. Files with scores less than 0 will NOT be added to the quick launch list.

TIP: To add files in a quick way, open up Windows Explorer or any file manage, and simply drag and drop files onto this window.


Aliases

The aliases page allows you to define your own custom search terms to associate with specific files or groups of files. An alias can be a single word or a full pharse; partial matching is performed against aliases just as with file names. You will probably want to use alias names that do not match any existing files on your system, thogh this is not a requirement.

When you add or edit an alias, the above form is displayed - open up a Windows Explorer window and drag new files for the alias into the window; you can rearrange the items in this list through cut and paste.

Note that both shortcuts and regular files can be added to the files listed in an alias. You can manually add commandline arguments to files.

The score associated with an alias is the exact score that will be given to all entries when a match is found with the alias.

You can now set optional hotkeys for each alias. Pressing the hotkey will bring up FARR (if hidden) with the alias results shown (i.e. as a menu).

Customize the Appearance:

You can customize the text that gets displayed with each entry by prefacing custom text with |

For example:

Play Solitaire | c:\program files\games\solit.exe

File Window Options:

You can customize the way programs are launching by adding one of a few optional window modifiers to the very end of your file specification. See here for more info.


Results Window Operations

Normally you just type the number associated with the result file you want to launch, or hit Enter (or Tab) and then select the file and hit enter, or double-click the item.

However, you can also right-click on a specific result for a menu of additional options:

From this menu you can:

· Add an explicit rule for the file. This lets you penalize or reward the current result, which will make it appear higher or lower in te results list on subsequent searches. This adds a rule to the Launch History list.
· Add a pattern rule for the file's directory. From here you can penalize or reward an entire subdirectory or arbitrary pattern. This adds a rule to the Pattern Scoring list.
· Explore at the location of the found file. If the result was found in the start menu, this will open windows explorer to the start menu subdirectory of this shortcut.
· Explore at linked location. This will open the directory where the shortcut points.
· Search for all matches. This will cause your current search to be re-run, with no limits on the number of results returned. This can be useful if your search returned many results and you are not sure if the file you are looking for is among those shown. This is a one-time search - if you type new search string, the limit specified in the Main Options will be back in effect.
· Launch and stay open - Normally when Find and Run Robot launches a file, it closes automatically - here you can launch a program and leave Find and Run Robot open for more operations.


Tip: Use Batch Files and Scripts

You can use Find and Run Robot to trigger all kinds of tasks, like shutting down windows, opening a bunch of files at once, cleaning your system, etc.

Remember that Find and Run Robot is simply a tool to help you launch other applications by name. For things like shutting down windows, you just need to find a small utility to shutdown windows and install it, making sure to put a shortcut somewhere in your start menu.

For more advanced takes, all you have to do to add your own commands to the program is create appropriately named batch files or script files and put shortcuts to the batch files somewhere on the start menu. You can rename the batch file shortcut to anything you want. Then use that name in Find and Run Robot to trigger it.

Avoid other utilities that insist on putting an icon in your system tray - if you're going to be triggering these from Find And Run Robot, you don't need these utilities eating up your system resources. Remember that the Find and Run Robot tray utility was designed to be super lean and efficient.

Links

· web page with some shutdown freeware - http://www.moochers.com/index.html?w95startshut.html
· web page with some batch making freeware - http://www.webattack.com/freeware/system/fwauto.shtml


Keyword Modifiers

Keyword modifiers are new as of version 2.02.01 (January 7th, 2007)

They let you indicate that certain search directories and pattern matching scores should be engaged only when the user specifies special modifier keywords during search, using the +KEYWORD syntax.

This can be extremely useful if you want to search certain directories only in special cases.

· For example, you might normally search only your start menu, but you want to search your "MyDocuments" folder and your "Documents and Settings" folders when the modifier "mydocs" is used.
· To do this, add the new directories and specify the keyword mydocs in each case.
· Now, to search for a file with "money" in its name, in these folders you could type: "money +mydocs" or "+mydocs money".
· FARR will know that in this case it should search in these two additional folders

Note that the choice of keywords is entirely up to you, you can use any strings you want for them.

You can also use keyword modifiers on scoring patterns:

· For example, you might not normally care about search for mp3 files, but you want to be able to find them easily.
· So add a new score pattern of *.mp3 with a score of 3000, and use the keyword modifier mp3.
· Now when you type in +mp3 in your search, all mp3 files will get a huge boost in score.

WHAT HAPPENS WHEN AN ENTRY HAS NO KEYWORDS

The default search directories and scores have no keyword modifiers. This means they apply ONLY when no keyword modifiers are specified in search string (or when one is specified but it doesn't match anything). Sometimes you want an entry to run if certain keywords are specified OR if no keywords at all are specified.

ADD blank TO MATCH ON NO KEYWORD AS WELL AS THE ONES SPECIFIED

To specify that a directory should be searched when NO keyword modifiers are specified in addition to when others are, add the special term blank as one of the space separated keywords.

ADD * TO MATCH ON ANY KEYWORD

You can also specify a keyword of * to say that the entry should be used when any keywords are specified.

TIPS AND TRICKS

· Each directory pattern or score pattern entry can have multiple keyword modifiers, separated by spaces.
· You don't specify the + when you are configuring an entry, but you must specify it when typing a search in the main form.
· Feel free to use the same keyword modifiers in multiple scoring and directory entries for maximum benefit.
· If you want to match on all keywords except a specific one or two, use the keyword * followed by "-KEYWORD" for keywords to reject,


Non-contiguous Search Words

Prior to v2, FARR interpreted multiple space-separated words on the search string as PHRASES.

New in v2, if you type a phrase (e.g. adobe photo shop) then FARR will *prefer* if it finds this string as a phrase, but will also tolerate finding the words out of order, or partially complete (for example the file PHOTOSHOP would be matched by pho sho, though with a lower score).


Search Edit History

New in version 2, your last 20 typed searches are remembered, you can scroll through them from the edit box by using Ctrl+Up and Ctrl+Down.


Negate Search Words

New in Version 2:

To reject all results containing a specific word, just prefix the word with a minus sign, -

Like:

Blondie -wav

to find all results with the word Blondie in them, except filenames containing wav (search includes the extension)


Hotkey and Shortcut Summary

From Search Panel:

Ctrl+Alt+Enter | Launch ALL items in result list (useful with alias groups)
Ctrl+Left or Alt+Left, Ctrl+Backspace | Delete last word (or subdir) in search edit box
Tab or Ctrl+Right or Alt+Right | Autocomplete subdirectory in search edit box
Ctrl+Up and Ctrl+Down | Scroll through older searches
Alt+O | Open preferences
Alt+# , Ctrl+# , Ctrl+Alt+# | Launch items in different ways (see preferences)
Alt+Enter | Open file/folder in search edit box
Enter | Launch first item in resuilts
Escape | Select search edit text for overwrite, or close window if already selected (double click)
Function Key # | Launch item #

From Results Panel

Ctrl+C | Copy path of result to clipboard
Ctrl+R | Show right-click menu
Ctrl+T | Show custom statusbar buttons as a menu under cursor


Using Alias Action Keywords

A new feature with FARR version 2 is the ability to specify alias names in your search string using the + prefix (just like keyword modifiers).

When an alias name is specified in this way, anywhere on the search string, it does not effect search, but it will cause the alias results to be displayed AFTER the result file is selected, with the selected file name as argument $$1 in the alias.

In this way, you can perform a normal file/folder search and then launch a specific alias command with that file/folder as an ARGUMENT.

For example, you could create an alias named +hexedit

whose result contents are:

C:\Program Files\HexEditors\HexEdit.exe "$$1"

Now you can type in your search:

+hexedit mydocsearch...

As you type mydocsearch words, FARR will let you search for files as normal.

After you choose the result, instead of launching the result file, you will be presented with

C:\Program Files\HexEditors\HexEdit.exe "SELECTEDFILE"

Which you can then launch.

NOTE:

You can use the same keyword for both alias names and search/scoring keyword modifiers.


Restricted Search to Files or Folders

When you use keywords to search, you can set a default option for whether to show folders in the results list.

But should you want to override this, you can add search modifiers to adjust the behavior:

Add +\ to show only matching folders (or -\ to hide folders)

Add +. to show only matching files (or -. to hide files).


Using Clipboard Tricks

FARR v2 has some tricks to help you use the clipboard in various ways.

First, you can check the checkbox on the General Options tab to tell FARR to copy any selected text to the clipboard when ever FARR is triggered, for use in commands.

Then, you can use the clipboard in your Alias Groups in various ways. For example imagine that we select the text "DonationCoder" and then trigger FARR:

One way is to write %cliptext% in an alias command, which will be replaced with clipboard contents.

· So an alias might be: gsearch | http://www.google.com?query=%cliptext%
· When user types gsearch is will open a search with clipboard text (DonationCoder)

Another way is to use $$c in an alias command which will use the $$1 regular expression field IF it exists, or else clipboard if not.

· So an alias might be: gsearch $$c | http://www.google.com?query=$$c
· When user types "gsearch hello" it will open a search to hello
· When user types "gsearch" it will open a search to DonationCoder

Another way is to specifically type $c in your search string to have it replaced with clipboard text:

· So an alias might be: gsearch | http://www.google.com?query=$$1
· When user types gsearch hello it will open a search to hello
· When user types gsearch $c it will open a search to DonationCoder

Also see the "copyclip" virtual action entry.


Alias Launching Tricks

You can now do some special stuff with aliases.

Customize the Appearance:

You can customize the text that gets displayed with each entry by prefacing custom text with |

For example:

Play Solitaire | c:\program files\games\solit.exe

File Window Options:

You can customize the way programs are launching by adding one of a few optional window modifiers to the very end of your file specification:

/winmax

/winmin

/winhid

/closeafter (force farr window to close after launching even if not set to by deafult)

/stayopen (dont close farr window after launching)

/icon=localfilename_from_aliasdir.ico (icon file must be in same dir as the source xml file defining the alias)

/hideifnoexist (hide the result if the file specified does not exist)

/runasadmin (run the file as admin)

For example:

Play Solitaire | c:\program files\games\solit.exe /WINMAX

You can now specify multiple programs to launch within one alias by separating them with ;;;

See also the #filecontents special virtual string to grab alias results from a file.

See also the help pages on Clipboard Tricks and Alias Action Keywords and Virtual Launch Strings..


The noresults alias

You can now create a special alias called noresults.

If user hits enter when no results are shown, this alias will be triggered.

It can be useful if you want to do something like launch what they type directly (as if it was on path), or invoke another search program, etc. Just use $$1 in the results.

Important: you need to set the regular expression pattern to:

^noresults (.*)$


Using Alias pattern of * to match all searches

If you specify * as your alias name (search pattern) or regex pattern, then the contents of the alias will be matched against ALL searches.

In this case, the contents are filtered against the search.

The effect of this is that every item in the contents is treated as if it were a mini alias -- it's a useful way of quickly adding a large number of results and items that are searched against what the user types, without having to create a new alias for each item.


Special/Virtual Launch Strings/Commands

Normally in an alias you specify the name of a file to launch/open (or url), but you can also use a few virtual launch strings instead:

· paste STRING_TO_PASTE - copies text into clipboard and then into last running app
· copyclip STRING_TO_COPY - copies text into clipboard
· restartsearch STRING_TO_SEARCH_FOR - restarts a new search by replacing editbox text (use \s at end of line to add a space after the new search string). Use \n at the end to simulate the pressing of Enter after the search is conducted (useful especially for plugins triggers).
· dosearch STRING TO SEARCH FOR - doesnt change the editbox but causes FARR to display results as if user had typed the string. very useful in conjunction with regular expression patterns.
· dosearchontrigger STRING TO SEARCH FOR - doesnt change the editbox but causes FARR to display results as if user had typed the string. very useful in conjunction with regular expression patterns. like dosearch but only happens when user hits Enter.
· dolaunch STRING TO LAUNCH - like dosearch except it triggers an immediate launch of the specified line as soon as a match is made with search string (i.e. user does not have to hit enter or otherwise trigger result). Note: you can use restartsearch as the string after dolaunch.
· showmemo TEXT WITH \n AS NEWLINES - lets you specify some text to display in results area in Memo mode.
· showfile FILENAME - to display in results (you can use virtual folder names). Use showfilertf and showfilehtml to force filetype.
· showhtml HTMLCONTENT - displays html content in html view mode
(in HTMLCONTENT you can use href links of the form "farr://launchstring" where launchstring is anything that would be in an alias result line).
· htmlviewurl URL - grabs a web page url and displays content in html view mode (this can be http://.. or file://)
· showfilehtml FILENAME - show a file in html mode
· setfocus searchedit | mainpanel - sets focus to either the search edit box or whatever output mode (results, memo, html) is currently showing (result list, htmlview, richedit view). Example: If you wanted to load a web page and then change focus to the html view (since by default it stays in the edit box now), you could make your alias result like this: htmlviewurl www.google.com ;;; setfocus mainpanel
· setviewmode list | memo | html | user | spreadsheet - sets main panel view mode. setviewmode would be used by a plugin that wants to keep the display in html mode for example without having to reload a webpage again and again. it would be called by plugin like: farr->set_strvalue("launch","setviewmode html"). It's hard to think of a case where anything but a plugin would call this.
· pcommand EXTRA_TEXT - sends a command to the current plugin and then to all other plugins if the current one doesn't handle it; sent via a plugin->set_strvalue("pcommand",EXTRA_TEXT) call -- so plugins need to return FALSE from this if they do not handle it. An ERROR will be announced to the user if no installed plugin accepts the command. This can be a useful way for plugins to talk to one another, so you should use EXTRA_TEXT strings that are uniquely identifiable.
· pscommand plugindllname EXTRA_TEXT - sends a command to the specified plugin; sent via a plugin->set_strvalue("pscommand",EXTRA_TEXT) call -- so plugins need to return FALSE from this if they do not handle it. Note specify the dll name but omit path and file extension.
· setsize MINWIDTH,MINHEIGHT,MAXWIDTH,MAXHEIGHT - forces size of window to be within the specified range; you can use -1 or * for values to ignore. So for example to force farr window to an exact height you could do: setsize 640,480,640,480 or to make sure its at LEAST 640x480 you could do: setsize 640,480,*,* or to make sure it is no larger than 640x480 you could do: setsize *,*,640,480 or to make sure its at least 640 pixels wide: setize 640,*,*,*
· sethtmlsafe 0|1 - tells farr that the contents of the html view are safe for triggering farr:// links. This can be used to override the default assumptions that pages loaded locally or set with showhtml are safe, and those from the internet are not. Set this after you have requested that the page be loaded or after you have modified a page downloaded from the internet.
· showpleasewait [MESSAGETEXT] - shows a please wait message in the main panel (can be blank), hiding the html and memo contents; especially useful if a plugin wants to download a page, modify it, and only then show it.
· hidepleasewait - removes the please wait message and shows underlying mode.
· alert MESSAGETEXT - show a simple messagebox with text, useful for debugging.
· sleep MILLISECONDS - sleeps for a while before continuing to the next launch command, useful when multiple launch commands are specified, separated by ;;;
· waitforhtml - returns after html browser contents are fully loaded
· appcap FILEPATH - runs an app and waits for it to finish, redirecting stdio capturing any commandline output in %lastappcap% (normal commandline window is hidden and not shown).
· appnowait FILEPATH - runs an app and captures output but doesn't wait for it to complete before continuing launch string execution.
· appcapappendmemo FILEPATH - runs an app and shows output in memo mode as it is outputted by the console program. If you want to show some custom intro text, call showmemo first before calling this.
· appcapappendmemons FILEPATH - runs an app and shows output in memo mode as it is outputted by the console program. If you want to show some custom intro text, call showmemo first before calling this; does not auto scroll to bottom.
· setuservar USERVARNAME=VALUE - sets the value of a user variable (e.g. setuservar twitter.username=donationcoder)
· tempmemofont PARAMETER - sets the memo font to something else temporarily (until next search). PARAMETER can be: fixed | custom. fixed sets a fixed font and is useful for console output sometimes. custom uses the custom configured font in the options.
· print TEXT - prints some text on the default printer.
· addlaunchhistory fname - adds the specified file or folder name to launch history
· addsearchhistory string - adds the specified string to the search history
· gomemobottom - goes to bottom of memo results
· recachedirpaths - re-evaluate any directory paths they may have environment strings or user variables that may have changed

· #filecontents FILEPATH (can use %ALIASDIR%), to have the contents of the file dumped into the alias results when searching. -- note this can currently only be used an alias group results (not callable by plugin). You can now use this recursively.


Using a regular expression alias for complex searches

Regular Expression Aliases as Search Templates

New with version 2 is the ability to make an alias that recognizes a regular expression pattern typed by the user, and BEHAVE as if the user had typed in something else (presumably more complicated). We call these Search Templates.

This can be very useful when you have certain search strings that you reuse often.

For example, let's say you often do a searches like this :

+audio .mp3 Dylan

+audio .mp3 Blondie

+audio .mp3 Bratmobile

You can now create an alias which makes this easier. Just create a new alias, give it any name you want, and choose a regular expression pattern, like

^msearch (.*)

And now the important part. for the results, put a single entry as follows:

dosearch +audio .mp3 $$1

Now when this pattern is matched by the user typing something like:

msearch Dylan

Then FARR will behave as if the user had typed:

+audio .mp3 Dylan


Regex Alias Filter Patterns

When creating an alias that uses a regular expression, you usually want to capture some part of the string typed by the user and use it in a file launching operation or web url.

[regular expression parsing is provided by the open source PCRE library]

For example you might use a regular expression like:

^search (.*)

With a result that opened:

http://www.google.com?search=$$1

In this way, the pattern matched by the (.*) is replaced in the url on launch.

Each alias can have multiple results that are shown on a match.

Normally, you want to display all results and let user choose from them like a menu.

However, it is now possible to let the user filter and score the results inside a regular expression alias, by specifying an optional filter/score pattern.

By specifying a filter/score pattern using the $$ notation, you can let the user filter only the results they want.

NEW:

You can use $$u1 and $$uc in place of $$1 and $$c to have FARR perform urlencoding on the arguments, making them suitable for web searches.

$$h1 can be used to do encoding of high ascii characters as &#XX; format

For example, in our search alias we might have 20 different search engines we know how to search. So we configure our search alias with these 20 result urls, and we make the following changes in our regular expression alias:

Regular Expression:

^(.*) search (.*)

With RegEx Search Filter

$$1

And results:

http://www.google.com?s=$$2

http://www.yahoo.com?s=$$2

http://www.altavista.com?s=$$2

NOW, a user can type: yahoo search hello

And the $$1 group name (yahoo) will be used to filter out all results in the the result list that don't contain the word yahoo, while the $$2 phrase will be used for the actual search.


Special Search Phrases

You can type the following special search phrases into FARR:

gooptions - show the options dialog.

gohelp - show the help file.

gotoolbar - show toolbar configuration page.

goabout - show the about/licensekey dialog.

gowebpage - open the Find+Run Robot web page.

helpfarr - show a list of these special search phrases above.

agroups - list all known alias groups.

historys - list past searches.

historyl - list past launches.

aplugins - list all installed plugins.

listfarr - show a list of these special search phrases above.

goreload - reload all plugins and aliases

goareload - reload all aliases

preload - list all plugins and let user choose a specific one to reload.

rplugins - Reload all plugins (prompting first after unload), which is useful for plugin developers to give them an opportunity to copy over a new version of their plugin dll.

goquit - exit program


Special Search Modifier Keywords

You can add the following special modifiers to your search to affect the results:

+sall

show all matching results, bypassing the normal limit on result count

+alias

match search only against aliases

-alias

do not show any matching aliases (only files)

-history

do not give bonus scores to items in history

-.

do not show any files, only folders (and aliases)

-\

do not show any matching folders, only files (and aliases)

+\

show matching folders


Tips and Tricks

Here are some tips and tricks for using Find and Run Robot efficiently:

· Hit escape from the search editbox to highlight your current search string and allow you to type a new one without backspacing.
· Hit pause/break key to close Find and Run Robot immediately (only works if launched from tray trigger).
· Hit enter twice to switch from the edit box to results window and launch the top entry.
· Hit down arrow to move into results window, or up arrow to move back to search edit.
· Right-click on a found result for more options.
· Give an item a score <-999 to keep it from ever being shown, even if it matches and nothing else does.
· Use \# to specify a digit in a filename when you've got the "Digit Keys Launch Results" option checked.
· If you don't want Find+Run Robot to minimize to stay running and minimize to the tray when closed, pass "-standalone" as a commandline argument to a shortcut for FindAndRunRobot.exe.
· See the list of Special/Virtual Launch Strings
· You can now specify multiple programs to launch within one alias by separating them with ;;;
· You can add \n at the end of a search string in an alias or hotkey configuration to launch the result immediately.
· You can launch all items in result list by hitting Ctrl+Alt+Enter.
· You can launch an item as an administrator by holding Ctrl+Shift as you launch it (or adding /runasadmin to the result in alias list)

Tips and Ticks on the DC Forum:

· Using the fcalc plugin with custom regular expression: http://www.donationcoder.com/Forums/bb/index.php?topic=13749


Variable Replacements, Virtual Folder Names, Env Paths

The following virtual folders are available for specification in the search folder list. Using them won't effect search speed and can keep your configuration valid even if you use a portable usb drive, etc.:

· %USERPROFILE%
· %USERNAME%
· %ALLUSERSPROFILE%
· %MYDOCUMENTS%
· %MYFAVORITES%
· %MYDESKTOP%
· %ALLDESKTOP%
· %MYSTARTMENU%
· %COMMONSTARTMENU%
· %PROGRAMFILES%
· %MYPICTURES%
· %MYMUSIC%
· %MYVIDEO%
· %MYAPPDATA%
· %COMMONAPPDATA%
· %COMMONMUSIC%
· %COMMONPICTURES%
· %COMMONVIDEO%
· %FONTS%
· %SYSTEMDIR%
· %FARRDIR%
· %CONFIGDIR%
· %FARRUSERDATADIR% - Defaults to the MyLocalData directory in FARR path which is the recommended place to store user settings and user-modifiable files that should not be overwritten on farr updates. this can be customized by the user to be anyplace on drive.
· %ALIASDIR% - When specifying alias commands you may occasionally want to refer to the home directory of the alias.
· %PLUGINDIR% - Directory of currently triggered plugin.
· %APPDRIVE% - Will be something like "C:" based on drive where findandrunrobot.exe was launched

You can also use any windows Environmental variable which provides more replacements (see here), like %WINDIR%,%PATH%, etc.

Additionally the following variables can be retrieved and passed on the commandline by aliases (or queried by plugins):

· %LASTHWND% - integer value referring to the last window handle that had focus before FARR was triggered.
· %LASTURL% - last url navigated or set in internal web browser
· %LASTURLSET% - last url explicitly set by alias/plugin in web browser
· %CUSTOMFILEBROWSER% - user configured custom file browser string
· %CUSTOMWEBBROWSER% - user configured custom web browser string
· %MAXRESULTS% - current number of max results to show in results, based on search
· %MAXRESULTSDEF% - option set by user for default max results to show in results
· %MAXRESULTSEXT% - option set by user for extended max results to show in results
· %LASTWEBERRORS% - blank if no web script errors since last web page load, or text of errors.
· %SEARCHBOX% - contents of current search box as shown.
· %SEARCHSTRING% - current search string; may differ from search box based on alias dosearch manipulations.
· %CURRENTRESULT% - currently selected result; useful for creating hotkeys that use it, etc.; blank if nothing selected
· %CURRENTRESULTNB% - same as above, but = first result if nothing selected
· %ALIASPREFIX% - optional alias prefix configured by user (this is useful to plugin writers in particular who need to set the search box contents.

You can also use relative directories in the search folder tab:

..\etc (up one directory)

\blah (on root directory of the program drive)


Alias Files

Starting with version 2.00.90, FARR has dramatically changed the way that aliases are stored and managed.

In the past, all aliases were stored in the main FindAndRunRobot.ini configuration file.

This made it harder to share aliases and update built-in aliases, because it was impossible to distinguish between user modified aliases and aliases written by others.

Starting with v2.00.90 (May 25, 2007), FARR now gets all of its aliases by scanning a special directory for multiple alias files stored in xml format.

These .alias files are located in the AliasGroups\ subdirectory of FARR, and are further broken up into AliasGroups\Installed and AliasGroups\MyCustom.

All alias files in the first subdirectory (\Installed) are considered READ-ONLY, and the user will not be able to modify these aliases (though the user can disable aliases and alias files).

These alias files are meant to be replaced on upgrading, and new alias files written by 3rd parties can be "installed" into FARR simply by copying the .alias files into this directory (or a subdirectory of it).

Alias files in the second subdirectory (\MyCustom) are alias file(s) that the user can use to create custom aliases. They will not be replaced on update. You can create new alias files for yourself by simply creating a new alias file in that directory - you will start out with 1 default custom alias file.

The format of the alias files are identical so its fine to create an alias file in your custom area and then share it with someone who will put it in their Installed subdirectory.

You can also specify a default icon to be used when displaying results from the alias by providing a file ALIASFILENAMEWITHNOEXTENSION.ico in the same subdirecory as the alias file. (This icon can be overridden for different results in the alias, see here).

You can also now set UserVar initialization values to be used with an alias, by defining the <DefaultUserVars> in your .alias xml file as follows:

<DefaultUserVars>[TwitterPlugin]$$$// twitter plugin login settings -- change to your values$$$ username=YOUR_TWITTER_USERNAME$$$password=YOUR_TWITTER_PASSWORD$$$</DefaultUserVars>

Use $$$ to separate newlines in User Variable lines.


Commandline Options

You can start FARR with some commandline options for advanced usage.

NOTE: You can launch a second instance of FARR with these arguments, and they will be PASSED ON TO THE FIRST INSTANCE and executed, without actually leaving a second instance running (so don't specify -exit unless you want to kill all running instances)

· -standalone = start FARR visible and in taskbar, and exit on close of window
· -search "search string" = start FARR visible (or bring up any running copy) and start a search
· -show = start FARR visible (or bring up any running copy)
· -hide = hide FARR if visible
· -toggle = toggle display of farr
· -exit = exit any running copy of FARR.
· -exitifnotrunning = exit FARR unless it was already running and this was a second instance launched just to search or launch
· -launch = start FARR (or invoke in a running copy) and launch a command (can use any normal FARR launch strings including setting user variables, etc.)


Html View Mode

Overview

New in version 2.03 (June 2008 release), is a feature that embed's a mini web browser in FARR that can display arbitrary html content and automatically download web pages. This is referred to as "html view mode".

Html view mode is currently rendered using the IE activex dll as an embedded web browser. This means that it will use the version of the Internet Explorer engine installed on the user's pc, and can support displaying anything that can be displayed in a normal browser. [In the future we may support an option to use the FireFox gecko engine].

While the html view mode in FARR can be used to display standard web pages, the intention is not to provide yet another web browser. The main purpose of the html view is to allow custom plugins to have greater flexibility in the way they display information.

See the topic Special/Virtual Launch Strings for the launch strings that can be used in your aliases to display html or load a webpage in the internal html view.


User Variables - Advanced Use

FARR now supports user variables which can be set in the Options Dialog:

These user variables are an easy way for aliases and plugins to read values and settings that the user can customize.

While plugins can create their own settings dialogs, this is especially useful for alias options, such as parameters and login information.

These values are stored inside the FindAndRunRobot.ini settings file.

The format for the User Variable area is:

[SectionName]

// comments

variablename=value

variablename=value

To replace a variable in an alias use:

%uservar.SectionName.variablename%

To get a value from a plugin call:

get_strval("uservar.SectionName.variablename")

To set a value from a plugin call:

set_strval("uservar.SectionName.variablename",value)

A plugin can also get all variables with:

get_strval("uservarlist");

get_strval("uservars");

An important feature of user variables is the ability to set some initial default values from an alias file (or a plugin). In this way when your alias is first loaded it will create sample values for the user to modify, which makes it easier to explain to the user what variables to set.

In an alias xml file include the following section:

<DefaultUserVars>

[TwitterPlugin]\n

// twitter plugin login settings -- change to your values\n

username=YOUR_TWITTER_USERNAME\n

password=YOUR_TWITTER_PASSWORD\n

</DefaultUserVars>

NOTE: you need to use \n at the end of each line (because of xml removal of whitespace).

From a plugin you can do the same thing by calling the following each time your plugin is loaded:

set_strval("DefaultUserVars","[TwitterPlugin]\n// twitter plugin login settings -- change to your values\nusername=YOUR_TWITTER_USERNAME\npassword=YOUR_TWITTER_PASSWORD\n");


Passing commandline parameters/arguments

You can now pass commandline arguments to any launched program by typing "++ any args here" at the end of your search string.

For example:

ping.exe ++ donationcoder.com -n 2

· Note1: you dont actually need the space AFTER the ++ but you do need it before the ++.
· Note2: you can use this ++ method both on programs launched via explicit directory browsing, and on those contained within alias results.
· Note3: ++ specified arguments will be ADDED to any existing arguments, so you can combine them.
· Note4: An alias can even specify WHERE exactly in the argument list they should go by using %comlineargs% in the launch string. This makes the ++ technique a very simple way of passing optional info to a non-regular expression alias.


Introduction

A Major New Feature with Version 2 of FARR is a powerful Plugin system.

Plugins are written as standard MS Windows DLLs, using any language that can create such DLLS (C,C++,Delphi,VB, etc.)

· How do I Install a Plugin? Just move the entire Plugin directory that you unzip into the Plugins/ subdirectory of Find and Run Robot. For example C:\Program Files\FindAndRunRobot\Plugins\MySamplePlugin. To uninstall a plugin just delete it from the Plugins/ subdirectory (you can also simply DISABLE it from FARR options).

· What can Plugins Do? There are several things a Plugin can do:

It can provide additional files or urls that FARR will search and filter automatically.

It can do it's own search and filter and generate results.

It can takeover launching of some or all files/urls.

It can generate results that have no meaning except to the plugin, which the plugin will "launch"

It can generate results that only other plugins know how to handle.

It can adjust the scores of other results generated by FARR or other plugins.

· How can I Configure a Plugin? You can see the list of installed plugins from the Options dialog on the Plugins tab. Here you can temporary enable or disable plugins, and find information about each installed plugin. There are also some default options for each plugin that you can adjust.


Plugin API/SDK

There are more than a dozen plugins for FARR, available in a variety of languages including: C++, C++ Builder, Delphi, Python, Javascript, C#.

These plugins have been made available with source code and for now they serve as the defacto plugin documentation.

In addition to the plugin-specific functions you can call and variables you can query, make sure to examine the Special/Virtual Launch strings for aliases that you can call from your plugin to launch special things.


Commands Callable by Plugins

This function can be invoked by a plugin on the FARR host:

host->callback_set_strvalue(COMMANDNAME,VALUE)

· launch, LAUNCHFILENAME_OR_SPECIAL_ALIAS_STRING

IMPORTANT NOTE: this is the command you will use from your plugin to do all kinds of things like display html, etc. by using the Special/Virtual Alias Strings.

· statusbar, TEXTTOSETONSTATUSBAR

· setsearch, TEXTTOSETINSEARCHEDIT

· setsearchnogo, TEXTTOSETINSEARCHEDIT

· stopsearch

· window.hide

· window.show

· window.toggle

· window.richeditmode, TEXTOPUTINRICHEDITWINDOW

· window.richeditheight, HEIGHTOFWINDOW

· window.richeditwidth, WIDTHOFWINDOW

· setshowallmode - tells farr to display ALL results returned by the plugin

· exit

· reporterror, ERRORTEXTTOREPORTINPLUGINLOG

· clipboard - set internal clipboard text (referred to by $$c or %cliptext%)

· PasteClipboardToLastActiveWindow,[TEXTTOSET] - paste the current clipboard text to the last active program (if value passed is not "" then clipboard will first be set to value).

· DisplayAlertMessage, TEXTTOSHOWINALERT (use \n to separate lines with first line being title) - this shows a non-modal alert box in lower right of screen that will fade away.

· DisplayAlertMessageNoTimeout, TEXTTOSHOWINALERT (use \n to separate lines with first line being title) - this shows a non-modal alert box in lower right of screen that will NOT fade away (requires user click).

· DisplayMsgBox, TEXTTOSHOWINALERT (use \n to separate lines with first line being title) - this shows a simple MODAL messagebox with OK button; all FARR processing halts until user hits Ok.

· DisplayBalloonMessage, TEXTTOSHOWINBALLOON (use \n to separate lines with first line being title) - this shows a non-modal system tray balloon message above FARR icon.

· EmbeddedWb.ExecJavascript, JAVASCRIPT CALL TO MAKE - executes some javascript on the loaded page
· (this tries to call back the plugin function set_strvalue("ExecJavascriptResult",returnvaluestring);

· DockUserView.ByHandle, POINTERTOWINDOWHANDLE - tells FARR to capture the window handle passed and take over as its parent. Your plugin then needs to call "launch","setviewmode user" to display the newly docked window. It is safe to call this multiple times, only the first time will it be acted upon.

· UndockUserView - tells FARR to undock the docked window and release it with no parent.

· receivekeys - tells FARR that the plugin should receive special keys (function keys, etc); when the display is in html mode or richedit memo mode; a plugin should call this before switching to html or richedit memo mode.

· addmenu.MENUNAME, MENUSTRING -- tells farr to add items (buttons/menus) to either the statusbar, or a result context menu. for more information see the help page on Adding Custom Menu/Button Items.

· postpluginlaunch LAUNCHSTRING - tells farr to run the following launchstring AFTER the plugins have finished running; most useful if you want to unload the plugin itself using "preload pluginname\n"

· ForceResultFilter - sets the search string used to filter and score returned results from a plugin (as if user had typed that string into search)


Values Getable by Plugins

These are invoked when the plugin calls the host function.

host->callback_get_strvalue(char* VARIABLENAME, char* destbuf, int maxlen):

· Handle.MainForm - return the windows Handle for the main FARR form window.
· Version.FARR - returns the full version string as shown in about box.
· Version.FARR_PLUGINAPI - returns the plugin api version (changes much less frequently)
· Version.FARR_PLUGINAPI_RELEASENUM - even simpler # of plugin api to make it easy to test feature compatibility.
· EmbeddedWb.Contents - returns contents of embedded web browser html contents (up to maxlen)
· EmbeddedWb.ContentsLength - returns a string integer of length of the embedded web browser contents.
· pvalue.[VALNAMEHERE] - replace [VALNAMEHERE] with the name of the value you want to ask a plugin to return. this function will call all plugins get_strvalue(VALNAMEHERE) until one returns a value. this can be a useful way to get information from other plugins. no error is reported if no plugin answers (return value will be set to ""). See also the pcommand alias launch string.
· resolve:[STRINGHERE] - expand the [STRINGHERE] string of any %KEYWORD% type strings, typically containing virtual path values (see here).
· resolvelnk:[STRINGHERE] - resolve the full shortcut lnk file path pointed to by [STRINGHERE] to the real file it points to (throwaway any shortcut args).
· resolvelnkwa:[STRINGHERE] - resolve the full shortcut lnk file path pointed to by [STRINGHERE] to the real file it points to with any shortcut args added to end.
· resolvefile:[STRINGHERE] - tries to find the file even if it has moved to another drive (useful for portable use)
· viewmode - returns either: list | memo | html | user | spreadsheet
· plugin_alias, plugin_regex, plugin_keywords, plugin_score - returns current value (ie if it has been overridden by user then the overridden value will be returned).
· Search.keywords - space separated list of any +keywords passed on search string
· uservars - the contents of the uservar editbox (with commands and section headers)
· uservarlist - a giant list of \n separated variablepath=value lines
· uservar.[SectionName.variablename] - return value of a variable
· score:[STRINGHERE] - far fills char* with ascii version of the floating point score value of the string, scored against current search terms.
·
· MainFormMonitor.CenterX - pass the address of an integer variable for destbuf; filled with center x coordinate of current main form monitor.
· MainFormMonitor.CenterY - pass the address of an integer variable for destbuf; filled with center y coordinate of current main form monitor.
· MainForm.Left - pass the address of an integer variable for destbuf, it will be filled.
· MainForm.Top - pass the address of an integer variable for destbuf, it will be filled.
· MainForm.Width - pass the address of an integer variable for destbuf, it will be filled.
· MainForm.Height - pass the address of an integer variable for destbuf, it will be filled.


Callbacks made by FARR to Plugin

The FARR host program can make the following calls to a plugin:

NOTE: THIS SECTION IS NOT YET COMPLETELY DOCUMENTED -- SEE SAMPLE PLUGINS!

In addition to the custom callback functions, FARR uses the set_strvalue callback function to do a variety of generic callbacks:

pluginp->set_strvalue(char* VARNAME,char* VARVALUE)

· "ExecJavascriptResult",returnvaluestring - the return value as a string of a previous call to ExecJavascript.

· "EmbeddedWb.NewWindow",url - user clicks on a web link that wants to open an external (popup) window.

Return FALSE to let the default action take place and let the page open; return TRUE to tell FARR not to open the window (your plugin can open it with it's own launch command if it wants).

· "EmbeddedWb.BeforeNavigate",url - user clicks on a web link that wants to open a page in the embedded browser.

Return FALSE to let the default action take place and let the page open; return TRUE to tell FARR not to open the window (your plugin can open it with it's own launch command if it wants).

· "EmbeddedWb.NavigationComplete",url - a new web page has opened in the embedded browser.

· "EmbeddedWb.DocumentComplete",url - a new web page has downloaded and it's contents loaded.

This would be the place where you might want to get the embedded web browser document contents and modify them before they are actually displayed.

· "ViewmodeChanges",VIEWMODESTRING - tells plugin in control about a change of view mode.

VIEWMODESTRING is from list | memo | html | user | spreadsheet

· "OptionsChange",1 - tells plugin that the options or user variables have been changed, in case the plugin needs to respond to these


Available Plugins and Alias Packs

For an up-to-date list of available plugins (and alias packs) for FARR, see this page:

http://www.donationcoder.com/Software/Mouser/findrun/addons/


Plugins and User Variables

See this topic for information on how to interact with user variables in the options tab:


Adding Custom Menu/Button Items

There are a few ways that plugins can customize the farr interface, including setting custom statusbar icons/menus, and custom right-click context menu items for results.

To customize these you use the farr->set_strvalue command, for example:

FARR.setStrValue("addmenu.statusbar","type=item|caption=MyTest|hint=this is hint|icon=help.ico|launch=restartsearch help");

This tells farr to add a button item to the statusbar (far right on bottom) which when clicked performs the launch action "restartsearch help".

When to Call addmenu:

It's important to know *when* you should call the addmenu command for different kinds of menus.

The statusbar "menu" gets cleared after every search -- because it's meant to show icons and menu buttons only relevant for the current search. So you need to call addmenu at the start of every search where you want to add items.

The "contextmenu" addmenu command must be called at a very specific time, only after farr requests it from your plugin. This happens when your plugin received an AllowProcessTrigger call with triggermode=PrepareContextMenu.

Syntax of addmenu commands:

call FARR.setstrvalue("addmenu.MENUNAME","MENUSTRINGS")

MENUNAME can currently be from: statusbar,contextmenu (more possibilities will come in future versions).

MENUSTRINGS has the following syntax:

Multiple items are separated by newlines (\n).

Each item consists of multiple field assignments separated by a | pipe character.

Each item must begin with a first field assignment of type:

type=TYPENAME

where TYPENAME is from: item, submenu, endmenu, separator

The item type describes a menu item or button; except for endmenu and separator types, it must contain a caption assignment, but others are optional:

caption=TEXT TO DISPLAY FOR MENU ITEM

icon=NAME OF FILE TO USE AS ICON, EITHER FULL PATH OR PLAIN FILENAME IF REFERING TO FILE IN FARR ICONS\ DIRECTORY

hint=TEXT TO DISPLAY ON MOUSE OVER

launch=LAUNCH COMMANDS TO RUN IF USER CHOOSES ITEM (SEPARATE MULTIPLE WITH $$$, SEE HERE FOR MORE HELP).

The submenu type should have a caption and can also have an icon and hint; launch values are ignored.

All items after a submenu are treated as children, until an endmenu type is parsed. You can nest submenus.

For example:

FARR.setStrValue("addmenu.statusbar","type=submenu|caption=GO2|icon=web\ntype=item|caption=MyTest|hint=this is hint|icon=help.ico|launch=restartsearch micro word \ntype=endmenu");

Other stuff:

Call FARR.setstrvalue("clearmenus","")

to clear the current statusbar icon menus. This can be useful if you want to change the statusbar icons after a result is triggered, and/or after switching to html or memo mode.


Can't Launch Programs/Documents

If FARR is not launching a file or document, there are several things that could be wrong.

1. Experiment with the different "launch methods" that FARR supports, in the options dialog General Tab. See this thread for more info: http://www.donationcoder.com/Forums/bb/index.php?topic=13779.0

2. Some security programs can interfere with FARR's launching of programs. For example the Comodo HIPs program causes the error "Windows cannot access the specified device, path, or file. You may not have the appropriate permissions to access the item" to be shown. For more info see: http://www.donationcoder.com/Forums/bb/index.php?topic=18716

3. FARR fails to launch files with hidden spaces at the start or end of their filenames.. If most files open with FARR but some fail.. Find the file and see if it has an extra space at the end of the filename.


Related Programs

Related Applications:

· Tray Command Line - http://traycl.chat.ru/ - shareware, $10

Very nice, *tiny* application - the inspiration for this program; does not search for files, but allows you to manually create aliases to launch from they keyboard.

· Key Launch - http://software.xfx.net/utilities/kl/index.html - shareware, $12

Similar to this program, incrementally searches through the start menu. Felt a bit clunky to me, and short on configuration options.

· Key Launch - http://www.konradp.com/products/keylaunch/ (freeware)

· RunIt! - site unknown

Very good program - has similar search functionality as Find and Run Robot and additional features for terminating apps, etc. Runs as a toolbar.

· ShellSearch - http://www.harmonyhollow.net/ss.shtml - freeware

Very similar in spirit to Find and Run robot, but not quite as fast to use. Free though, and lots of nice other apps by this developer too.

· WinConsole - http://galan.dogmalab.ru/index.php?lang=eng&look=soft&item=winconsole - shareware $10

Similar to Tray Command Line, with support for hotkeys and lots of options.

· Meta Launcher - http://www.codesector.com/commandline.asp - shareware $15

Nice looking app which also comes with a startmenu replacer and app launch bar type feature

· OpenExpert - http://www.baxbex.com/openexpert.html - freeware

Adds context menu to open files with a menu of applications.

· LaunchItNow - http://www.gemiscorp.com/english/launchitnow.html - freeware

Launch bar type app.

· Stargate Link Boss - http://www.lincolnbeach.com/stargate.asp - shareware $20

Launch panel app.

· Shell Search - http://www.harmonyhollow.net/ss.shtml - freeware

Similar to find and run robot.

· MCL - http://mlin.net/MCL.shtml - freeware

Similar to Tray Command Line but with some nice addons.

· CMDBar - http://www.pitrinec.com/pcb_index.htm - shareware

Persistent bar on screen that lets you type commands and has other functions.

· Smart Launch - http://www.pxcompany.com/en/sl/index.shtml - shareware $18

· 1st TurboRun - http://www.turborun.com - shareware $25

· CrossLaunch - http://methodik.pixelarmy.org/readme.html - freeware

· JetStart - http://www.codesector.com/jetstart.asp - shareware $19.95

· ESP - http://www.espsw.com/index.php - shareware $10 - very close in functionality and approach.

· SlickRun - http://www.bayden.com/SlickRun/ - freeware

· Run! - http://crimsonfan.altervista.org/ - freeware

· AppRocket - http://www.candylabs.com/approcket/ - shareware (.net) $18

· QuickFind - http://mitglied.lycos.de/quickfind/ - freeware

· Rock-It-Launcher - http://www.brunswim.com/RIL/

· Ava Find - http://www.think-less-do-more.com/avafind/

· Luanch-n-go - http://www.tethyssolutions.com/launch-n-go.htm - shareware

· FileTracer - http://www.filetracer.com/ - shareware

· Task Tracker - http://tasktracker.wordwisesolutions.com/index.html - shareware

· Instant Document Search - http://www.sowsoft.com/document-search.htm - shareware

· Getchoo - http://alilm.needlemen.com/drupal/?q=node/2 - donationware

· CuteType - http://www.tooto.com/cutetype/ - shareware

· RunFast - http://www.idiogensoftware.com/runfast/index.htm - freeware

· ZenKey - http://www.camiweb.com/zenkey/index.htm - freeware

· KbStart - http://www.kbstart.com/ - shareware

· Mayk - http://www.beotel.net/~darkdst/ - freeware

· Locate - http://locate32.webhop.org/ - Freeware

· FastFind - http://www.guyswithtowels.com/dev/apps/fastfind.html - Freeware

· 99 Useful Run Commands - http://www.fixmyxp.com/content/view/20/42/

· Type and Run - http://galanc.com/index.html?page=5&lang=en - Freeware

· Filehand - http://www.filehand.com/

· Trip - http://trip.glenmurphy.com - freeware

· Launchy - http://www.launchy.net/ - freeware open source

· VistaGlance - http://www.vistaglance.com/vg_screenshots.html

· Triniaut - http://trininaut.sourceforge.net/

· Faster Than Ever - http://www.yazalim.com/products/fte/index.htm - freeware

· yubnub - http://www.yubnub.org/ - free web service

· Semex - http://smx.wickedorange.com/?page_id=3

· Direct Access - http://www.nagarsoft.com - shareware

· FindOnClick - http://www.2brightsparks.com/foc/index.html

· StartEase - http://www.pcmag.com/article2/0,1895,2064854,00.asp - shareware

· SmartStartMenu - http://www.planetharrington.com/products/smartstartmenu/

· Guillotine - http://www.zchromosome.com/ - freeware

· SmartStartMenu - http://www.planetharrington.com/products/smartstartmenu/ - freeware

· SpeedStart - http://www.speedstart.net/ - freeware

· Enzo - http://www.humanized.com/products/enso/launcher/ - shareware

· QT and MGES - http://members.at.infoseek.co.jp/Quizo/freeware/indexEn.html - freeware

· AcceleRun - http://www.svarsoft.com/ - shareware

· KeyBreeze - http://www.keybreeze.com/

· Path - http://www.xtort.net/xtort-software/path/ - freeware

· Executor - http://www.executor.dk/ - freeware

· Trininaut - http://trininaut.sourceforge.net/ - open source free

· Pretty Run - http://delphistep.cis.si/prettyrun.htm - freeware

· Skylight - http://www.candylabs.com/skylight/ (from makers of approcket) - free for now?

· Dash - http://trydash.com/home/ - shareware+freeware

· Google Desktop Extreme - http://www.podsync.com/gdx.htm - freeware

· Faster Than Ever (FTE) - http://www.yazalim.com/products/fte/index.htm - freeware

· DOMercury - http://www.odierno.com/domercury/Default.aspx - freeware

· QiiNinja - http://www.qiininja.com/

· Giraffe - http://www.ric.hi-ho.ne.jp/giraffe/index_en.shtml - open source free

· Keyboard Extensions - http://www.saleensoftware.com/KeyboardExtensions.aspx

· Speed Launch - http://www.officelabs.com/projects/speedlaunch/Pages/default.aspx

· Serk - http://kailashrocks.googlepages.com/

· Google Gadget "Run" - http://desktop.google.com/plugins/i/run.html?hl=en

· Fingertips - http://www.getfingertips.com/

· Google Search Box - http://www.google.com/support/toolbar/bin/answer.py?answer=81305

· TheSearchMan - http://venussoftcorporation.blogspot.com/2009/08/thesearchman.html

· Snow Bird - http://lmadhavan.com/software/snowbird/

· Blaze - http://blaze-wins.sourceforge.net/index.php

· Start++ - http://brandontools.com/content/StartPlusPlus.aspx

· Launch-n-go - http://www.tethyssolutions.com/launch-n-go.htm

· JumpTo - http://sites.google.com/site/apathysoftworks/home/jumpto

· UltraSearch - http://www.jam-software.com/ultrasearch/

· Promptu - http://www.promptulauncher.com/


Version History and To Do List

 Top Previous

VERSION HISTORY

Version 2.90.01 - Aug 18, 2010

· [MajorFeature] Faster wakeup display from minimized state (see also the StayInMemoryLonger option on General Options tab)
· [Feature] Alias matches now show instantly even when keypress delay option is enabled.
· [BugFix] When you do not have "stop on exact alias match" checked and an alias was matched, it could show large numbers of results.
· [Feature] New install of farr now adds the search directory %PROGRAMFILES64% which will search in the win64 specific program files directory (not just the Program Files (x86) directory); older users should add this directory manually.
· [BugFix] When launch results had an argument that ended in \ it could mess up launching of them
· [BugFix] When the option to show FARR in taskbar when active was set, there was an additional delay before FARR could start accepting characters after unminimizing.
· [MinorFeature] Added text in options tabs reminding people to right-click to add/edit/delete items.
· [MinorFeature] Added version of appcapappendmemo that doesn't scroll to bottom of memo.

Version 2.87.03 - May 4, 2010

· [MinorFeature] appcapappendmemo now auto scrolls to bottom of memo.
· [MinorFeature] new alias launch string to explicitly go to end of memo (gomemobottom)
· [MinorFeature] modified text in alias dialog to make clear alias name was also trigger text
· [MinorFeature] attempt to remove some blinking from memo mode when text doesn't change.
· [BugFix] attempt to extend max length of environmental variable replacement in things like search directories
· [Feature] you can now refer to the currently selected result (or first result) using a variable replacement (%CURRENTRESULTNB%); especially useful for triggering actions via hotkey.
· [Feature] you can now recursively include file contents with the #filecontents alias string.
· [Feature] improved and documented the use of * for alias pattern to always match search against contents.
· [Feature] added -exitifnotrunning commandline option and clarified help on others.
· [Feature] added error on commandline args that aren't understood.
· [Feature] now checks the return value from plugin Initialize function; if false is returned, the plugin is not loaded. This could break plugins that have been returning false from the Initialization function in the past with no effect.
· [Feature] you can now ask FARR to recache the search folder directories and re-resolve any user variable or environment variables, using the recachedirpaths launch string.
· [Feature] added ewemoa's "fhelp" alias file that provides direct links into farr chm help file based on matching
· [Feature] errors parsing xml files are now reported (and saved to troubleshooting log)

Version 2.86.01 - February 28, 2010

· [BugFix] - Non-contiguous matching was not happening within alias results.
· [BugFix] - PgDn during searching was retriggering search even if it was already in showall mode.

Version 2.84.01 - February 15, 2010

· [BugFix] - Search directories were not expanding environmental variables.
· [Feature] - Added /hideifnoexist (hide the result if the file specified does not exist)
· [BugFix] - Result labels for items with /options could be messed up (hopefully i haven't broken anything while fixing this)
· [Feature] - Added new ability to specify search text to simulate on blank search box. By setting text here you are asking FARR to simulate a specific search when there is nothing in the search edit box. Useful if for example you want to specify the contents of an alias result on blank search.
· [BugFix] - An alias result that starts with %uservar.% will be replaced prior to being listed -- useful for using user variables for paths, etc.; in the past the resolution happened only at launch time.
· [Feature] - Typing just +modifierkeyword to restrict search to certain directories will now list those directories.
· [MinorFeature] - Search text is added to search history when FARR is minimized or enter is pressed in search window.
· [Feature] - You can now hit PgDn from search box to tell FARR to find *ALL* results, not just the few that normally fit in the window; You can continue to hit PgDn and PgUp to page through results after that. When more results available the statusbar now hints about PgDn.
· [MinorFeature] - New option to disable non-contiguous matching when doing a show all search.
· [MinorFeature] - A few tweaks that may speed up search a tiny bit.
· [BugFix] - Option to show on taskbar was not working.
· [BugFix] - Attempting to improve a black flicker on win7 (or slow pcs) when auto-resizing window.
· [MinorImprovement] - Improved search directory keyword modifier instructions.
· [Feature] - New option to disable non-contiguous searching when in Show All (+sall or PgDn) mode, to help weed out extraneous matches and speed up search (set by default).
· [BugFix] - Hopefully fixed bug that could cause crash if exiting while searching.
· [Feature] - Added ability for plugins to add items to launch and search history (addlaunchhistory,addsearchhistory).

Version 2.81.01 - November 22nd, 2009

· [BugFix] - The myaliases.alias file (where custom user aliases are stored) was not being created on the first run for a new user (only on second run).

Version 2.80.01 - November 20th, 2009

· [Feature] - Ability to customize titlebar, including ability to put date and time in it.
· [BugFix] - Users can no longer delete built-in hotkeys (but they can be disabled).
· [MinorFeature] - Added option to disable troubleshooting log.
· [Feature] - You can launch an item as an administrator by holding Ctrl+Shift as you launch it (or adding /runasadmin to the result in alias list)
· [Feature] - The launch history and search history are now saved to independent files (in config dir) instead of the ini file; allows faster save of bigger lists, and means less paranoia when moving and sharing normal ini settings file.
· [MinorFeature] - Improved text of options dialog for history options.
· [MinorFeature] - When reducing the number of items to keep in history, it now truncates the current list.
· [BugFix] - When launch history reached max, new items were not being added.

Version 2.77.02 - August 27th, 2009

· [BugFix] - When option to use numpad keys to launch was set, numpad keys could not be used for memo/html mode typing of numbers (which hindered their use in calculator plugins for example).
· [BugFix] - Changing skins preview while options dialog was open sometimes showed larger window than it should.
· [BugFix] - Triggering toolbar button with .lnk file argument was not resolving the lnk.
· [BugFix] - Farr was showing more results than it should if an alias used the dosearch action.
· [BugFix] - Alias action modifier launching was not working.
· [BugFix] - When launching alias results that were .lnk files, the /showmax type alias arguements were not obeyed.
· [MinorFeature] - some options moved to new tabs in options.
· [BugFix] - Moving and deleting items in one of the option lists could on rare occasions lead to an error when loading the ini file on next run (would report bad ini file and reset to defaults).
· [MinorFeature] - Using the paste special alias command now pastes \r\n when the \n constant is found in the paste text.
· [Feature] - You can now customize the result background color for the main results window and search edit box.

Version 2.75.01 - July 21st, 2009

· [Minor Feature] Attempt to speed up first display by pre-checking file existence in history.

Version 2.72.01 - July 17th, 2009

· [Minor Feature] You can now use the dolaunch alias command (which launches a result without user having to hit enter), to restart the search, and simulate them pressing enter using \n.
· [BugFix] The dolaunch alias that was used to show an html page was clearing the page before it could be seen.

Version 2.71.01 - July 12th, 2009

· [BugFix] Icons for shortcut links with custom icon settings were not being shown properly due to change in v2.70.01; hopefully now this is fixed and the previous x64 shortcut/icon fixup stuff is still working.

Version 2.70.01 - July 7th, 2009

· [BugFix] Using the igo alias multiple times could result in an error about "Resource In Use" for users with old versions of Internet Explorer 6 installed.
· [BugFix] Attempt to fix icon display and launching for some .LNK shortcuts (especially x64 programs on x64 OS); let's see if this breaks anything for other users.
· [BugFix] Clarified the statusbar display during initial searching.
· [MinorFeature] Program now checks file existence of previous launch history on startup which should avoid the delay on first search.

Version 2.68.02 - June 29th, 2009

· [BugFix] The myalias.alias user alias file was not always being created.

Version 2.68.01 - June 29th, 2009

· [BugFix] Using the new "dolaunch" feature when your hotkey is set to not-clear text resulted in FARR launching the item every time it was displayed.
· [BugFix] The visit alias and explore here right-context menus were not being shown appropriately for all result items.
· [MinorFeature] Added values that plugin can get to help center pop-up forms on the current monitor displaying the FARR main form.

Version 2.67.01 - June 26th, 2009

· [BugFix] Pressing * on numpad was ignored if you had the "launch with numpad option set"
· [MinorFeature] Plugins can now call resolve:filename to have FARR fixup the location of a file if the drive letter has changed.
· [MinorFeature] Toolbar buttons that try to perform a restartsearch by invoking the FindAndRunRobot.exe are now simply passed along directly to the running process.'
· [MinorFeature] Toolbar button links are now resolved if they refer to files whose drive letters have changed (portable use).
· [BugFix] Calling setsearch and window.show from a plugin was causing hidden window to appear but search text to be ignored. Hopefully the fix won't break anything -- let me know if it does.

Version 2.66.01 - June 21st, 2009

· [BugFix] Fixed bug where plugin functions OnProcessTriggerV2 were not being called if OnProcessTrigger didnt exist in the plugin dll (even though it was never used).
· [MinorFeature] Added pscommand which works just like pcommand except you can specific dll to send a pscommand to by specifying the dllname first.
· [BugFix] Fixed bug with alert messages moving the main form on multimon systems.
· [MinorFeature] Added print command that aliases or plugins can call to send some simple text to the printer.
· [BugFix] Visit this alias context menu item was not showing right caption sometimes.
· [Feature] Added help page on troubleshooting.
· [Feature] Added clearmenus command that plugins can call to clear statusbar icon menus.
· [Feature] Upgraded to latest version of EmbeddedWb web browser component (http://www.bsalsa.com/)
· [Feature] Added function "score:" that plugins can call to have farr score a string based on current search terms.
· [BugFix] On IE6 and earlier, repeated plugin calls that use html view (jscalc,czbpack plugins) could hang. Thanks JoTo!

Version 2.63.01 - June 5th, 2009

· [Feature] Added option to always reset search string when hotkey triggered (default is old behavior which is to just refocus farr window if already on screen).
· [Feature] Added new alias action called "dolaunch" which is like dosearch except it triggers an immediate launch of the specified line as soon as a match is made with search string (i.e. user does not have to hit enter or otherwise trigger result).

Version 2.62.01 - May 30th, 2009

· [Feature] Added runcap built in alias to shell a commandline tool and show its output in FARR window (see this forum post).
· [Feature] Improved seed of changing/interrupting search of plugin -- should speed up some plugin searches that return lots of results.
· [BugFix] Variables weren't being replaced in the #filecontents command.

Version 2.61.01 - May 25th, 2009

· [BugFix] Autofixing of missing paths was changing root drive letters to a valid drive; now only more specific search paths which are found on moved drives are fixed.
· [BugFix] A blank showmemo which would be useful to clear memo before running appcapappendmemo was not working, now it does.

Version 2.60.02 - May 20, 2009

· [Feature] - Added "appcapnowait" launch command to launch an app to capture its output, but continue running launch strings without waiting for it to finish.
· [Feature] - Added "appwait" launch command to launch an app, NOT capture its output, and wait for completion before continuing.
· [Feature] - Apps run through "appcapappendmemo" and associated functions that write into memo live are now terminated if user starts a new search.
· [Feature] - Added display of extra info in statusbar as appcap and related functions are running.
· [BugFix] - Hiding slide numbers was messing up display [fixed in v2.60.02]
· [Feature] - Added keyword -history to temporarly disable, on the current search, the use of and scoring modifications from the launch history list.

Version 2.59.01 - May 15, 2009

· [Feature] - Added launch command "appcapappendmemo" to show console tool output as it runs instead of at end.
· [Feature] - Added launch command "tempmemofont" to temporarily switch memo font to fixed font (useful for some console tools which use spacing/tabs).

Version 2.58.01 - May 13, 2009

· [MinorFeature] - Added $$h1 available in aliases like $$u1, for useful encoding for curl commandline.
· [BugFix] - Folder icons were not being displayed properly since v. 2.57.01.
· [Feature] - Added troubleshooting log in options dialog -- can be used to log debug/troubleshooting info.
· [Feature] - Plugins that crash the program on load are now auto-detected and temporarily disabled.
· [BugFix] - Large icon results sometimes resulted in too small window during autosizing.

Version 2.57.01 - May 2, 2009

· [MinorFeature] - You can now choose how to handle large 48x48 icons when the windows system is configured to use Large Icons, and these will display properly.

Version 2.56.02 - April 24, 2009

· [BugFix] - Replacement of variables was happening prematurely in alias launch strings; hopefully this bugfix doesn't cause unintended changes in behavior.
· [Feature] - You can now pass commandline arguments to any launched program by typing "++ any args here" at the end of your search string.
· [Feature] - New Search Behavior Option that lets you enable or disable(default) scoring of files in explicit directory browsing mode.
· [BugFix] - #filecontents and other references to %aliasdir% results stopped working in v2.56.01

Version 2.55.01 - April 19, 2009

· [MinorFeature] - Added variables accessible by aliases: %SEARCHBOX% (contents of current search box as shown) and %SEARCHSTRING% (current search string; may differ from search box based on alias dosearch manipulations).
· [MinorFeature] - Updated to be compatible with new VclSkin Builder version 5.
· [MinorFeature] - Added modal messagebox function DisplayMsgBox that plugins can call.
· [BugFix] - DeleteAll from launch history wasn't working.
· [MinorFeature] - Added commandline option -launch.
· [Feature] - Added delayed search initiation option.

Version 2.54.01 - March 28, 2009

· [BugFix] - the new setuservar alias launch string wasn't working right.

Version 2.53.01 - March 24, 2009

· [BugFix] - Web browser errors were being shown as popups when they shouldn't be.
· [Feature] - Added variables available to aliases and plugins for querying %LASTURL%, %LASTURLSET%, %CUSTOMFILEBROWSER%, %CUSTOMWEBBROWSER%, %MAXRESULTS% and more.
· [Feature] - Added ability to set uservars from an alias launch string.
· [Modification] - Changed the way non-regex plugins are passed the nonlcsearchstring: the alias keyword trigger is now removed from the string passed to the plugin.

Version 2.52.01 - March 16, 2009

· [BugFix] - Fixed a very rare bug that was causing crashed on some pcs (thank you David A. for the help tracking this down)

Version 2.51.01 - March 15, 2009

· [BugFix] - Some plugin alias results were being shown even in directory browse mode.

Version 2.50.01 - March 12, 2009

· [BugFix] - the #grabfile alias results trick wasn't working if you didn't precede it with a "label |" prefix

Version 2.49.01 - March 10, 2009

· [Feature] - Web browser mode now handles javascript commands to close the window without crashing with OLE error.
· [Feature] - Some dynamically created javascript ajax scripts in test plugins were failing to run.

Version 2.48.01 - February 24, 2009

· [Feature] - added variable %APPDRIVE% for portable use.
· [Feature] - added new launch virtual command "waitforhtml" that attempts to wait until the web browser contents are loaded.
· [Update] - updated to latest version of EmbeddedWebBrowser control.
· [Feature] - added "appcap" launch command which will shell a commandline program, capture its output into %lastappcap% and wait for it to finish; useful for running a program and displaying its output in memo or html mode.
· [Feature] - added ability to put in a separator in a custom menu.
· [Feature] - Ctl+R and Ctrl+P in edit box now work as if you had selected first item and then hit those keys (shows context menu or custom menu)
· [Feature] - Ctrl+T will show any custom statusbar buttons as a menu.
· [Feature] - Plugins are now sent Tab Key (#8) to takeover if they want (but plugin must return TRUE to receivekey call to take it over; other more general keys may be added)
· [Feature] - Type "goareload" to reload all aliases (but not plugins)
· [BugFix] - File extension restrictions in search directory configuration no longer affect folder name searching
· [BugFix] - Typeing + or - at end of search string yielded unusual results
· [Feature] - Tweaked Leftmost bonus scoring heuristic to try to improve points added for matching on left side of words.
· [Feature] - Attempting to improve automatic url encoding of web urls -- still not perfect but hopefully improved.
· [Feature] - Added new ability to use $$u1 and $$uc to explicitly ask farr to urlencode a search string arguement.
· [Feature] - Added new option to hide system tray completely (when farr is minimized).
· [eFeature] - EXPERIMENTAL - tried new code to show history on blank search which gives plugins a chance to trigger. Needs testing.
· [Feature] - Directory entries can now contain multiple directories, separated by ; which is useful if you want to use an environmental path like %PATH%.
· [Feature] - Added %ALLDESKTOP% and %USERPROFILE%\Application Data\Microsoft\Internet Explorer\Quick Launch to preconfigured default search directories.
· [Feature] - In an alias contents you can now specify #filecontents fullfilenamewithpathhere (can use %ALIASDIR%), to have the contents of the file dumped into the alias results when searching.

Version 2.45.01 - January 4, 2009

· [Feature] - added "appwait" launch command which will shell a commandline program, display its output in normal commandline window (not capture it), and wait for it to finish before continuing.
· [BugFix] - character constants \n were not always being replaced properly in memo display mode.

Version 2.43.01 - December 31st, 2008

· [MinorFeature] - Added postpluginlaunch call for plugins.
· [BugFix] - Using \n when doing restartsearch wasn't always working (with special buildin aliases like preload)
· [BugFix] - Trying to allow launch modifiers (like /winmin) on each launch of a multilaunch ;;; separated line
· [BugFix] - Icons in custom context menus were not being shown correctly.
· [BugFix] - Custom icons in statusbar were not all being shown.

Version 2.38.01 - December 18th, 2008

· [Change] - Plugins that wish to receive special/function key presses in memo/html mode now need to call set_strvalue("receivekeys","") explicitly when switching into those modes; previously this was not necessary. This change was needed to handle cases where FARR was guessing incorrectly about which plugin should receive the keypresses (only one plugin can).
· [BugFix] - Selecting an item in aplugins list sometimes caused error.
· [MinorFeature] - Added new "preload" search string which can be used to list and then reload a specific plugin.
· [MinorFeature] - Getting a uservar now resolves any %replacements% in it.
· [MajorFeature] - Plugins can now create custom statusbar icons/buttons/menus.
· [MajorFeature] - Plugins can now create custom right-click context menu items for results.
· [BugFix] - Changing size of window was sometimes being forgotten on restart.

Version 2.34.01 - November 30th, 2008

· [BugFix] - Directory browsing wasn't working if you had the "show folder matches by default" option unchecked.

Version 2.33.01 - November 3rd, 2008

· [BugFix] - Fixed problems with new UserVariables feature.

Version 2.31.01 - October 8th, 2008

· [MinorFeature] - Added Portable mode support (edit the configdir.ini file and add line PORTABLE=TRUE); when enabled no system files or any files outside of the program directory will be written.
· [MajorFeature] - New UserVariables tab in options, allows aliases and plugins to read custom values set by user in this area. This is an easy way to provide options that are independent from the plugin and alias files, such as user logins, etc. Aliases and plugins can also create default values which will be initialized in the UserVariables tab on first use.

Version 2.30.01 - August 5th, 2008

· [MinorFeature] - Added some new values plugins can get to tell the current (overriden) alias string, etc.

Version 2.29.01 - August 4th, 2008

· [MinorFeature] - Removed option to hide statusbar.. was causing trouble with skinning system and on reflection seemed to be a bad idea to hide info that might need to be displayed by plugins, etc.
· [MinorFeature] - Improve the right-click context menu for Explore Here, added "Visit this alias" for both partial alias matches and full alias results.
· [BugFix] - using \ during plugin searches didn't work for plugins using non-regex search matches.

Version 2.28.01 - July 29th, 2008

· [MinorFeature] - Added option to show file extensions only when doing explicit directory listings.

Version 2.27.01 - July 28th, 2008

· [MinorFeature] - Changed default memory use to "Average" (was Use More Memory When Minimized).

Version 2.26.01 - July 27th, 2008

· [BugFix] - Improved autosizing of window, especially with custom font overrides and skins.
· [MajorFeature] - You can now specify a list of extensions to restrict search to or exclude from searching in each search folder (when combined with search folder keyword modifiers this can be an efficient way of restricting search).
· [MajorFeature] - You can now specify an optional prefix to trigger alias/plugin matches (and wont match against them if not found).

Version 2.25.01 - July 26th, 2008

· [BugFix] - Some plugins were being called even when an initial explicit directory path was preceding the plugin alias.
· [MajorFeature] - Non-contiguous search option (enabled by default, searching for "ffox" will match "fire fox")

Version 2.24.01 - July 21st, 2008

· [MinorFeature] - Added alert alias launch string to help debugging aliases.
· [MinorFeature] - The %LASTHWND% replacement string is now available to aliases and plugins.
· [BugFix] - Using an action modifier alias on drive letters like C: will now replace with C:\ (slash at end)
· [BugFix] - Some plugin aliases were being listed if the search edit box contained only explicit path and modifiers.
· [BugFix] - The addnote alias was incorrectly referring to the helper addnote.exe file.
· [BugFix] - Pressing enter when a partial alias with one result should launch the alias but was autocompleting it instead; fixed.
· [MinorFeature] - You can add \n at the end of a search string in an alias or hotkey configuration to launch the result immediately.

Version 2.22.01 - July 11th, 2008

· [MinorFeature] - Plugin can get current viewmode.
· [MinorFeature] - Added commands to show a please wait display (useful for plugins).
· [Bugfix] - FARR was refusing to launch farr:// links in html mode if they were triggered by some javascript tricks.
· [Bugfix] - FARR was not calling plugin DocumentComplete function for showhtml commands.
· [Bugfix] - The embedded webbrowser OnDocumentComplete callback was triggering before web page text was available.

Version 2.20.01 - July 6th, 2008

· [MinorFeature] - A plugin can now ask FARR to resolve virtual folder paths.

Version 2.19.01 - July 6th, 2008

· [MajorFeature] - A plugin can now embed (dock) their own window INSIDE the farr window, in a user view mode. This lets a plugin generate any kind of output which is shown seamlessly inside farr and resized just like the normal farr contents.
· [BugFix] - Statusbar message sometimes got stuck saying "Searching plugins.."

Version 2.18.01 - July 5th, 2008

· [BugFix] - Mousewheel scrolling of html view from edit box was not always working; new method seems to be more reliable.

Version 2.17.01 - July 5th, 2008

· [Feature] - FARR now remembers the size of the window independently for each of the different view modes (list results, memo, html).
· [Feature] Added setsize command to set the window size of current display mode.
· [Feature] You can now right-click and choose to duplicate an alias item in a read-only alias file, and it will be duplicated in the myaliases alias file.
· [BugFix] Creating duplicate alias entries could sometimes cause access violation fault.

Version 2.16.01 - July 4th, 2008

· [Feature] - New launch command (pcommand) that aliases and plugins can call to ask another plugin to perform a function.
· [BugFix] - The ReceiveKey command was not being triggered in plugins in htmlview mode.
· [Feature] - You can now use Ctrl (or Alt) +(PgDn,PgUp,Home,End,Up,Dn) from the search edit in html mode to scroll the html window.
· [Feature] - You can now use the mouse wheel to scroll memo and html views without leaving search edit box.

Version 2.15.01 - July 3rd, 2008

· [BugFix] - Plugin customization options were not being saved.
· [Feature] - FARR now keeps focus in search edit box when showing html contents if that was prior focus state (painful).
· [Feature] - New launch commands (setfocus,setviewmode) that aliases and plugins can call to control focus and display mode.

Version 2.14.01 - July 2nd, 2008

· [BugFix] - But the remove-duplicates option back in Search Behavior tab -- used to be checked by default.
· [Feature] - All built-in "lists" are now filterable (agroups, aplugins, historys, historyl)

Version 2.13.03 - June 29th, 2008

· [BugFix] - The showfile launch command was not properly identifying html files as such.
· [BugFix] - FARR was sometimes refusing to follow far:// links in a file url fetched by file://
· [BugFix] - Create duplicate alias command was not working.
· [BugFix] - Disabled items on result pop-up menu were sometimes not shown as disabled; they are now hidden.
· [Feature] - Hitting tab with an alias result as first item now always puts alias group name in search box.
· [BugFix] - FARR was not shutting down smoothly with windows shutdown when certain plugins were loaded
· [BugFix] - Plugin reloading speed should be improved, as well as program exit speed.
· [Plugin] - Added multi-monitor-centering farr plugin to list of installable plugins
· [Change] - When an alias has only one result, that result is shown on a partial match, but only if its a non-regex alias and only if the result refers to a real file (otherwise the partial alias is shown).
· [BugFix] - Tab autocomplete behavior has been improved.

Version 2.12.01 - June 25th, 2008

· [Feature] - Redesigned the Options dialog to use an OptionTree.
· [Feature] - Settings file now uses buffered read+write which should dramatically speed up saving and loading of settings file.
· [Feature] - Added option to choose whether to use the old or new launch method.

Version 2.11.01 - June 21st, 2008

· [MinorFeature] - New aliases are now always added at the END of the list (makes it easier to find new ones; you can still drag+drop to re-order).
· [Feature] - Changed the way partial alias matches are displayed and launched. If there is only one result in an alias, then its single result contents is displayed in results (icon and launch file), and it is treated exactly like a match on that contents item. If there are multiple results, the alias name is shown along with a hint about contents, but now the icon from the first result is used for the alias display. This also allows you to simply hit enter to launch a single-result alias is matched partially.

Version 2.10.01 - June 18th, 2008

· [BugFix] - preventing recursive plugin trigger launch takeover.
· [BugFix] - eliminated (and fixed from previous install) the setting of the internet explorer user-agent string.

Version 2.09.01 - June 14th, 2008

· [MinorFeature] Alias launched files are no longer added to history.
· [Feature] Trying improved method to launch documents and shortcuts -- maybe will improve launching issues for that rare minority who have the launching problem.

Version 2.08.02 - June 14th, 2008

· [Feature] $$# regular expression patterns are replaced with blank strings if they are not found in capture groups in pattern
· [MinorFeature] Directory browsing now shows top directory in proper mixed case.
· [BugFix] Using arrow keys and tab from directory browsing now always pops focus back to edit box.
· [Feature] ShellExecute method changed -- hopefully this may fix failure to launch shortcuts for some people

Version 2.07.03 - June 13th, 2008

· [Feature] Disabled skinning of all but main form -- necessary change for now to support some html view browser activex dialogs.
· [BugFix] Fixed htmlviewurl to decode urls that use %20% and similar encoding strings.
· [Feature] - Created a new subdir under FARR dir called MyLocalData\ which is now the recommended place for installed aliases to save data that should not be overwritten on updates (the TiddlyWiki aliases use this directory for example).

Version 2.07.01 - June 13th, 2008

· [MinorFeature] When using the restartsearch special alias command, you should now add a \n at the end if you want it to simulate the pressing of enter after the search (useful especially for plugins triggers).
· [BugFix] Fixed bug with triggering restartsearch alias launch strings from plugins or links.
· [BugFix] Large clipboard contents (>1k) could cause FARR to crash if used with a hotkey that tries to use %cliptext%

Version 2.06.08 - June 12th, 2008

· [MinorFeature] Improved plugin help pages.
· [MinorFeature] Added commands and callbacks for plugins to work with embedded web browser.
· [MinorFeature] Added ability to auto process "farr://" links in html shown via showhtml alias command (wont work with internet loaded pages).
· [MinorFeature] Triggering a hotkey that has no forced searchtext while farr window is still on screen but not in front will now bring farr window to front without disturbing search edit contents and without reseting the output display.
· [Feature] Mouse buttons for back,forward,refresh,stop now work properly in the embedded web browser.
· [Feature] Disabled ActiveX loading in the embedded web browser for security purposes. Unfortunately this prevents any flash pages from being displayed. I will add an option to enable activex, and maybe even a mini whitelist feature for it. We need to discuss what the safest security features are for the embedded web browser.
· [BugFix] Attempting to fix DLL error on windows shutdown.
· [BugFix] Attempting to fix secondary DLL error on windows shutdown due to some plugins.
· [BugFix] farr:// links were sometimes being disabled due to incorrect security check.

Version 2.05.01 - June 9th, 2008

· [MinorFeature] Directory browsing now lists files in alphabetical order without differential scoring.
· [BugFix] Files named ".BLAH" where showing as "BLAH" in results without the leading period.
· [BugFix] Max recursion limit in search directories was 0.

Version 2.04.03 - June 9th, 2008

· [BugFix] Triggering an item in the "historys" command was closing FARR right away instead of showing past search in edit box.
· [BugFix] Removed ugly space at beginning of item labels when number display is disabled.
· [BugFix] Replacement of $$c could still cause recursive hang/crash.
· [BugFix] The restartsearch special launch string was closing window prematurely (also affected the noresults special alias).
· [Feature] The new release of FARR contains update links for most known plugins as of June 9th, 2008; they can now be installed from the updater.

Version 2.04.02 - June 8th, 2008

· [MajorNewFeature] Added balloon messages and alert box popups to Plugin API.
· [Minor Feature] When a in memo mode, the Home+End keys were not working as normal (to go to start and end of search edit text) and were instead being used to navigate the scrolled memo text. Now you have to use Ctrl+Home and Ctrl+End (and PgDn and PgUp) to scroll memo.
· [MajorNewFeature] Added KeyPressed messages to Plugin API, so plugins can detect special key combos while displaying their results.
· [MinorFeature] Minor tweaks to the options dialogs.
· [MajorNewFeature] html/web view mode added.
· [BugFix?] Fixed "launch all" shortcut? (Ctrl+Alt+Enter).
· [MinorFeature] Typing rplugins now reloads/rescans both plugins and aliases.
· [BugFix] Aliases using the $$c string to replace clipboard contents could cause recursive crash if clipboard text itself contained $$c.
· [BugFix] Alias labels (when alias result is configured as LABEL | PROGRAMTOLAUNCH) were not replacing $$c and %cliptext%
· [BugFix] Dragging and dropping an item in options tabs onto itself resulted in deletion of the item.
· [MinorFeature] Ctrl+A selects full editbox text (you can also use Escape key).
· [MinorFeature] FARR is now more suitable for portable use with regard to skin file location -- it will look in local Skin subfolder if the explicit path doesn't resolve to an existing file.
· [MinorFeature] Using the special launch string paste you can now use \r,\n,\t to escape characters
· [MinorFeature] Improved instructions for using the special noresults alias.
· [BugFix] After doing explicit directory browsing, if you cleared search window the default results would show with full paths.
· [MinorFeature] If hotkey is used to restore focus of FARR rather than un-minimize it, then the text will not be forced into editbox.
· [MinorFeature] Added option to minimize FARR when its window loses focus.
· [MinorFeature] Added option to disable the showing of any index numbers on results.
· [MinorFeature] Selection of rows in slide mode now only highlights the text.
· [Feature] You can now specify multiple programs to launch within one alias my separating them with ;;;

Version 2.00.144 - Oct 22nd, 2007

· [bugfix] showmemo command now properly converts multiple \n when displaying in text memo results.
· Added showfile command to show contents of a file into text memo results.
· [bugfix] All keyword modifiers are now forced to lowercase since mixed case resulted in failure to match when searching.
· You can now use Ctrl+PgUp, PgDn, ArrowUp, ArrowDn,Home,End to scroll result memo view.
· [bugfix] Using dashes in search should work now as long as it isn't of the form [SPACE]-WORD which will be treated like a work to exclude from search.
· [bugfix] Virtual folder replacements now intelligently handle \ directory separators, so you can write for example %FARRDIR%\scripts or %FARRDIR%scripts. This bugfix also fixes the case where cpanel items were shown twice.
· Added check-for-updates to plugin manager form.
· Added option to stop search on regex match, and default stop search on exact alias name match to false.
· [bugfix] alias files were sometimes getting extraneous fields saved in them.
· Added option to disable the +action modifier result replacement, where when there is only 1 result and you use a +action modifier, the result shows the action modifier text instead of the normal result text.
· A dosearch virtual launch string that is blank will now show history of past launched files.
· [bugfix] Double quotes were being lost on url searching.

Version 2.00.143 - Oct 13th, 2007

· On VISTA the installer doesn't offer to launch the program as it could run as administrative user.

Version 2.00.142 - Aug 19th, 2007

· Found folders were not obeying the result path option.
· Added a slight delay when triggering hotkey with the copytext option, to give more time for the copy to work.
· Added command callable by plugins: "PasteClipboardToLastActiveWindow" -- works well with the KK clipboard plugin.
· Disabled plugins are now completely unloaded (so no resource use if unchecked).
· Added environmental paths %FARRDIR% and %CONFIGDIR%
· Sped up search by removing outdated whitespace-removal search heuristic.
· Fixed error where you were unable to delete user aliases and instead got an error about them being readonly.
· Improved interaction with the updater on plugin updates.

Version 2.00.138 - July 25th, 2007

· Improved searching for plugins (just return ENTRYTYPE_UNKNOWN instead of file, if its not a file being returned in results list.
· Added special virtual launch string "showmemo" that will let an alias result display some text in the results area in memo mode.
· Improved processing of # characters in search string.
· Tried to improve clipboard capturing routine to eliminate a rare exception case.
· Backup ini files (automatically made when using a new version upgrade) are now stored in a BackupIni subdirectory.

Version 2.00.137

· Added option in hotkeys to pre-highlight search string.
· Special searchword agroups now displays the alias file for each alias; selecting an alias now shows full info in statusbar.
· You can now right-click and jump to the alias file of aliases in agroups.
· [bugfix] Explore Here right context menu item was showing up even on urls.
· [bugfix] The +sall option was not working on directory listings.
· [bugfix] Trying to solve a slowdown problem with shortcuts to UNC paths.
· [bugfix] # hash characters were being replaced in search strings.
· The 'aplugins' special search string now shows all plugins not just first 9.
· Added 'rplugins' search word to quickly reload all plugins (prompting first after unload), which is useful for plugin developers to give them an opportunity to copy over a new dll.
· Delete key in results now removed an item from history (if it is in history).
· Improved right-click pop-up menu (now shows directories for explore here, etc).
· Icon no longer shown on main FARR window.
· Modified default plugin scoring to not use custom user file pattern scoring.

Version 2.00.135 - July 20th, 2007

· Cleaned up some of the options.
· Added new option to set maximum window size for autosizing (useful for +sall).
· Custom font settings are now applied to statusbar and column header.
· Added new default Ctrl+Break hotkey for copying selected text to clipboard and launching FARR with search %cliptext% in searchbox, as a demo of the new hotkey system.

Version 2.00.134 - July 20th, 2007

· Completion (tab or alt+right) now will fill in the 2nd item if the first lists the current directory in edit box.
· Added more virtual folder names.
· [bugfix] Autocomplete tab was adding extra spaces.
· [bugfix] Scores for aliases were sometimes being reset to 0 on locales using comma for decimal separator.
· [bugfix] Some aliase results had an .ico type label due to icon specification
· Sped up display updating and responsiveness.
· Sped up launching of FARR second-instance commands from commandline.
· Improved autocomplete of shortcuts that link to "Installer{" style shortcuts.
· Improved tab/autocomplete for aliases (no longer completes non alias/files/folder results)
· Adding support for multiple matching action alias keyword modifiers.
· [major feature] Totally new and flexible hotkey system.

Version 2.00.133 - July 17th, 2007

· Disabled the new fade-in code for now as it was not working as well as hoped.

Version 2.00.132 - July 17th, 2007

· Added commanline options (-show,-exit,-search "search string") to let you control the running version of farr by launching a new version.
· Now detects an infinite recursion that can happen by a bad alias dosearch usage and reports it.
· The goupdate string now closes FARR window while launching updater.
· Set FARR alias files to use Legacy (not UTF-8) encoding by default when saving alias files; will solve issues with manually created alias files that use diacriticals.
· Modified the fade-in code so it will be faster and less jumpy.

Version 2.00.131 - July 15th, 2007

· More improvements of smooth refreshing.

Version 2.00.130 - July 14th, 2007

· Trying some new smarter delayed refresh routines, should lead to smoother update of display and less hard flicker/resizing.
· Added mouseover hints for more menus and options

Version 2.00.129 - July 13th, 2007

· [bugfix] cursor was not being placed at end of line after an alias restartsearch.
· [bugfix] right-click context menu for copying item path to clipboard was not removing custom \ICON stuff
· [bugfix] alias results with urls were showing \ICON in results
· Added feature to show plugin triggers when you type aplugins.
· Ctrl+left/right now move between words. Alt+left/right work as before, deleting last word and autocompleting.
· Fixed updating of hotkeys when options form is closed.
· Previously, including any \ directory components without an initial starting dir (like C:\) would trigger a long slow search starting at root of drives. Now if no initial explicit directory is specified, it does a standard search of configured folders for files containing the directory paths specified.
· Implemented small (500ms) delay between updating of results -- yields much faster directory browsing and somewhat faster display of results when there are lots of results.
· Clipboard text is now used with $$c only when it is <128 characters.

Version 2.00.127 - July 11th, 2007

· Modified it to work with new dcupdater to not cause the silly Vista UAC prompts.
· [bugfix] The special restartsearch alias command was placing cursor in wrong place.
· You can now use a \s at the end of your restartsearch line to add a space in editbox after replacement.
· Corrected many of the mouse-over statusbar hints.

Version 2.00.126 - July 9th, 2007

· Only one instance at a time is allowed to run, thanks to Florian Bömers OneInst component.
· Added option to configure tab to not auto-complete (use Ctrl+Right to autocomplete in this case)
· Display options now update right away when you adjust column options.
· Added options to use ctrl/alt to insert digits in search edit box.
· Directories with periods (.) in them were not displaying properly.
· Autocomplete (tab) on alias now puts alias in search editbox.

Version 2.00.125 - July 7th, 2007

· default alias folder icons are now not used if an alias result refers to a real program with an icon (but they will be used for non-program alias results).
· special alias search commands should now strip off /ICON extra stuff in alias.
· Added scrollbars to exclude subdirectory list in search directory dialog.
· Added plugin callable function "setshowallmode" to switch results into +sall mode.
· Double-clicking an alias that changes search (like an entry in agroups) now puts cursor back in edit box.
· Started putting icons in right-click results context menu, moved system submenus to top.
· [bugfix] When adding aliases via the right click results menu, they werent available until going into options dialog first.
· [bugfix] When using action alias keywords (like "notepad +search"), custom icons were not being shown.
· [bugfix] Results with UNC network paths (//) were causing FARR to pause and appear to hang for a few seconds.
· Added +alias and -alias special search modifier keywords to show only or no alias matches to search

Version 2.00.123 - July 4th, 2007

· [bugfix] custom fonts were not being enabled on initial start.
· Fixed a bug that could crash farr when closing options.
· Improved handling of plugins so that they aren't reloaded unless needed.

Version 2.00.122 - July 2nd, 2007

· Added ability to customize the plugin richedit display font (used by fcalc for example)
· Updated skin system.
· Fixed bug where column sizes were shifting between runs.
· Removed launch options like /ICON from statusbar display when selected a result.

Version 2.00.121 - July 1st, 2007

· [bugfix] go button to visit plugin web pages was not working in plugin manager form.
· Changed options for large icon mode -- now you have checkboxes for when to switch to small result mode, including switching whenever there are too many results for large mode (like when using alias lists and +sall modifier)
· Added 'aplugins' special search to list installed plugins and versions.
· Trying out new code to handle the ontop/non-ontop status management of farr window.
· FARR now creates the file that the updater uses to locate it, so even if you install it someplace custom, the updater will find it.
· Moved to reorganization of alias files by Hamradio (Carroll Dearstone), along with his wonderful icons for them.
· You can now see changes immediately when modifying display options.

Version 2.00.118 - June 30, 2007

· [bugfix] vista had messed up statusbar

Version 2.00.116 - June 30, 2007

· Improved the File -> Create new alias file command and fixed crash that occurred when using it.
· Added hints to some new options items, rearranged them slightly.
· Added "visit forum" to help menus.

Version 2.00.115 - June 29, 2007

· [bugfix] Result pop-up menu commands for adding results to aliases was not working.
· Removed useless option "tab autocompletes" -- tab now always autocompletes when applicable.
· Added option to not keep search history (good for paranoid people).
· [bugfix] - was crashing when keep-launchhistory size was 0.
· You can now create a special alias called noresults and if user hits enter when no results are shown, this alias will be triggered. Useful if you want to do something like launch what they type directly (as if it was on path), or invoke another search program, etc. Just use $$1 in the results.
· If you use an alias action keyword now, and there is only one result in the results, the alias action will show in results.
· Digit keys now work in the fcalc plugin and any other plugin which does not use results, even if you have the option set to launch using digit keys.
· Added option to customize fonts and fontsizes used by FARR.
· Added optional large number display in large icon (slide) mode.
· [bugfix] resizing the icon toolbar to 0 size was making it impossible to resize later.
· [bugfix] drag and resize of columns was malfunctioning.
· Some installer shortcuts don't really refer to a filesystem location -- jumping to them now jumps to shortcut directory.
· Added update checking integration with options.

Version 2.00.108 - June 12, 2007

· Improved alpha-fading in effect
· Added option to hide from taskbar or not
· Installer is now named FindAndRunRobotSetup.exe, and will close any running version during install or uninstall.
· FARR now appears quicker and does not miss initial keypresses.
· Jump to Dir menu option now adds \ at the end of the dir so that you can see contents of the directory immediately, and fixed bug which was truncating results.

Version 2.00.104 - June 9, 2007

· Added ability to exclude specific subdirectories (or subdirectory patterns) of search directories.
· Fixed bug that was allowing plugins with no alias string to make results blank.
· Improved FCalc plugin.
· Attempt to fix weird bug where FARR was hanging or losing its icon on rare occasions.

Version 2.00.99 - June 6, 2007

· Disabled alpha-fade by default on vista.
· Added new option (enabled by default) to display history matches even when they are not in current search paths; this is a change from recent previous behavior.

Version 2.00.98 - June 4, 2007

· Change options form font back to MS Sans Serif unless large font is detected.
· Fixed bug in use of ConfigDir.ini file which can override location of config directory.
· Added ability for aliases to explicitly invoke plugin dll commands, which allows plugins to offer lots of features and menus easily using the alias system.
· Plugins can now set size of richedit results.
· Rescanning for plugins now prompts user between unload + rescan, which can be useful for updating plugin dlls without exiting FARR.
· Released new live-calculation plugin: FCalc

Version 2.00.97 - June 3, 2007

· Added File menu items for creating new alias files.
· Added subdirectory (recursive) search depth value for search dirs
· Fixed bug where /ICON= tags were not being removed from url launches
· Added %ALIASDIR% replacement variable for if you want to put exe helpers in alias directory and launch from there.
· Regex replacement now takes place after /ICON= stripping and so clipboard or argument contents shouldnt fool it.
· When using an alias as an alias action keyword, and only one result is available, it will be launched right after hitting enter (instead of first showing the one result and requiring two taps of enter key).
· Tab key now autocompletes file names as well as folder names
· Fixed bug where using modifier +keywords was disabling search of some search dirs

Version 2.00.94 - May 30, 2007

· Major Change: Moving to external xml alias files.
· Fixed bug where position of window was sometimes not being remembered.
· Fixed minor bug where & character was not being displayed in statusbar.
· Fixed bug where non-contiguous word search was broken after a partial alias match.
· Added ability to specify custom icons in alias results (use /ICON=localfilename_from_aliasdir.ico).
· Stripped arguments from alias display.
· Added default icon display for alias files if alis file icon file found (should be same name and location as alias file but with .ico extension instead of .alias).

Version 2.00.84 - April 30, 2007

· Added option to use large icons iff in non-directory listing mode.
· Fixed bug where /STAYOPEN and similar alias result special keyword were hanging the program.
· Fixed bug where past-launched items found through an explicit directory path were not being searched during non-explicit typing.

Version 2.00.82 - April 26, 2007

· Added major new display mode (Slides mode with large icons).
· Fixed statusbar size bug in windows Vista.
· Improved default icon for Vista look.
· Simplemode was not being set as default on new installs.
· Initial skin file name was not displaying in drop down box in options.
· Changed default initial skin to RoueGrey-SLIM.

Version 2.00.79 - April 15, 2007

· Added special command goquit to exit program and added it to helpfarr alias.
· Added Quit item to menu in options dialog.
· Added alias contents modifiers /CLOSEAFTER and /STAYOPEN (see here).

Version 2.00.77 - April 10, 2007

· Fixed bug where hitting tab would bring you into the result list but not highlight first result.

Version 2.00.76 - April 07, 2007

· Fixed bug where hitting Enter on initial window display with history list showing wasn't working.
· ATTEMPT to fix some window redrawing issues involving the option to keep the FARR window ontop (may not work, let's see how the tester reports are).
· Fixed drag+drop in Alias add/edit form.
· Tab now autocompletes partial aliases.
· Fixed bug where aliases with $$1 replacements were trying to be launched when triggered, instead of autocompleting.

Version 2.00.71 - April 03, 2007

· Improved interaction with plugins (statusbar updates, etc.)
· Updated included FarrFox plugin to version 1.06.01 (now includes option to disable periodic rescanning, and manual rescan request "ff `")
· Modified plugin api
· Removed but that could slow down window display

Version 2.00.68 - March 29, 2007

· Alias contents now have some replacement code applied to them so you can use "\filename" to make it refer to current drive, or %PROGRAMFILES% fields, etc.
· Added %SYSTEMDIR% to virtual folder list.
· Updated included FarrFox plugin to version 1.03.01 (search not just FireFox plugins but also Opera and IE bookmarks).

Version 2.00.66 - March 27, 2007

· Added read-only checkbox to Alias items to mark them as protected built-in items that will be replaced on next update, and made FARR update these built in aliases on update. Just make sure you don't MODIFY the contents of these built-in aliases as they will be overwritten on update. HOWEVER, you can change score and disable them. So if you want to modify a built-in one, just disable it and create another below it.
· Added right-click option to duplicate alias.
· Added special search phrase "historys" which will list all past searches to choose from, and "historyl" which lists past launched files.
· Added ability to remove searches from list of past search history.
· Added a lot more built-in default aliases.
· Search directories are now left as virtual %MYDOCUMENTS% style, and resolved when FARR starts up, making it more suitable for use on portable drives.
· Added more virtual folder strings.
· Added parsing of relative directory paths in search folders list.
· Added a helpfarr built-in alias to show a menu of special commands (help, options, toolbarconfig, show all aliases, show past history).

Version 2.00.62 - March 24, 2007

· Fixed bug where the option to not close after launch was being ignored.
· Added option (and made it default) to launch all shortcuts using the helper tool instead of trying to resolve the shortcut and launch program directly [useful if you have shortcuts which launch with compatibility options and administrator rights, etc.].
· The agroups special keyword now shows more regex info when listing all known aliases.
· Added a first-use message in the system tray about how to activate the program.
· You can now drag+drop out urls from farr to browsers, etc.
· Modified reporting of history matches to respect folder vs. file display options.
· Modified reporting of history matches to respect current search folder modifiers.

Version 2.00.61 - March 16, 2007

· Fixed bug in the copyclip virtual launch string.

Version 2.00.60 - March 14, 2007

· Added special +sall modifier which says to show all matches and ignore the normal result limit.
· Tried to add code to prevent a situation where you type very fast and hit enter before results are updated (may need improving).
· Fixed bug where folder history items were being displayed inappropriately.

Version 2.00.59 - March 14, 2007

· Added columns in options dialog for modifier keywords and regular expressions.
· Added separate setting for # results to show when explicitly displaying directory contents.
· Fixed bug where first word of search was not filtering out results when the "match against full path" option is set.
· Fixed bug where '.' character (period) was not working as expected when searching for aliases with '.' in them.
· Action aliases (search for a file and specify a regex +ALIASNAME somewhere) were not working; let me know if i've broken anything in the process of fixing this.

Version 2.00.58 - March 13, 2007

· Fixed bug where first word was being ignored when search in a directory.
· Aliases results with regular expression substitutions was not being displayed on exact alias matches without regex patterns (see http://www.donationcoder.com/Forums/bb/index.php?topic=7574.0)
· Added new optional Regex Alias Filter Patterns.
· Fixed bug where non-regex aliases were not being shown.
· Alias contents results are now shown in their original configured order if no extra search terms are specified.
· Fixed bug where old values were showing in create new alias dialog.
· Improved the ctrl+left last-word-delete feature.
· Right-Alt key + # will no longer trigger launches, to behave well with non-english keyboards using right+alt as an extended shift key.
· When you trigger a partial alias that has only one result, the result is triggered (launched). In previous versions it simply auto-completed the alias which you then had trigger again.
· Fixed bug that would cause program to hang when processing unc path (local network // paths) files in history or alias results.
· Fixed annoyance where it was lowercasing some directory auto-completion results.
· FARR will now show results from multiple aliases IFF they all match exactly.
· You can now use the RUN alias to run programs on the path while specifying commandline arguments (just enclose argument string in double quotes).

Version 2.00.56 - February 25, 2007

· Fixed bug on using alias action keywords.
· Fixed bug which showed aliases when doing directory search and completion.

Version 2.00.55 - February 23, 2007

· Partial alias matches now show a hint about their contents (and can be narrowed based on content)
· Partial alias listings now show a count of # results inside them.

Version 2.00.54 - February 22, 2007

· Lots of bugfixes regarding alias searches that were broken with plugin support addition.
· Regular expression aliases now show hints on partial match.

Version 2.00.51 - February 20, 2007

· Added new virtual launch command which when triggered from an alias will cause a new search to begin with a specific string.
· Added ability to have a regular expression alias work as search templates and conduct an alternate search based on regex pattern.
· You can now filter/score alias result lists by simply typing more words after the alias name (yay! very helpfull)
· MAJOR NEW FEATURE: Plugin System added.
· First test plugin released: FarrFox

Version 2.00.48 - February 8, 2007

· Fixed initial display resizing for some startup alias settings.
· Added new Addnote helper tool (add a note by typing "addnote"; view notes with "viewnotes")
· Moved calc.exe to Helpers/ subdirectory.
· Clipboard text is replaced after FARR captures it on launch.

Version 2.00.45 - February 6, 2007

· Added option to force forms on top or not.
· Trying to fix crash on alt+p (preferences) from edit box.
· Escape to close options.
· Fix bug on alt+left in edit box when there is a path with spaces, and now it now leaves the \ at end of last subdir

Version 2.00.44 - February 6, 2007

· Added clipboard helper stuff.
· Added display sound option.
· Added fade-in option.
· Smoother/Faster display of form because it is prepped at closing time now.

Version 2.00.42 - January 3, 2007

· Added uninstaller shortcut to start menu (how on earth was this missing for so long!)
· Added shortcut files to control panel to the Scripts directory (clever idea suggest a long time ago on DC forum and first seen implemented in Launchy developers)
· Tab in results box now properly goes into the selected subdirectory and return edit to search box.
· File/Folder names with - (hyphen) in them no longer confuse the keyword detection which now check for preceding space and no following space.
· Updated dclagoa's latest robotDrop icon.

Version 2.00.41 - January 31, 2007

· Fixed transparency not sticking.
· Fixed resize form bug [thx Arjen]

Version 2.00.39 - January 29, 2007

· Fixed column resizing bug.
· Fixed extra space bug at end of columns when opening options.
· You can now re-order columns.
· General optimizations and speedups.
· Added optional date (last modified) column.
· Improved paste operations.
· Added variable %lasthwnd% that can be passed on command line and contains the handle of last active window before farr was shown.
· Fixed "search for all" function.
· Hopefully fixed a delay that could occur during searching sometimes.
· Another try at fixing z-ordering of dialogs.

Version 2.00.38 - January 22, 2007

· Fixed drag+drop issues in options and main form.
· Keyword modifiers now don't interfere with path completion.
· Fixed bug where some paths were not showing results if the "check full paths for multiwords" option was checked.
· Tweaked bonus points for word boundries on multiword search.
· Added new heuristic "File vs. Folder Score Ratio"; set to > 100 to prefer files at top of results, set to <100 to prefer folders at top of results.
· Option scoring changes mostly only have an effect now after the options form is closed.
· Added new modifiers to show only folders (+\) or only files (+.), or use - to invert.
· Improved descriptions of heuristics.
· Changed Folder vs File Heuristic default to 90.

Version 2.00.36 - January 19, 2007

· Completely replaced the internal result listview component to improve issues when hiding and resizing columns and for future optional view modes.
· Added new skin browser combo box - now you can super easily step through and preview each skin file with a single keypress.
· Fixed bug in using up+down arrows from results list and edit box.
· No more flashy blinky editbox and toolbar during results form autosizing.
· Added new icon from dclagoa, and improved other icons a bit.

Version 2.00.35 - January 17, 2007

· Added new Simple Options mode, hides most of the complex options.
· Added code to fit fonts properly even on Large Font installations of Windows (sorry if its hard to read).

Version 2.00.33 - January 16, 2007

· Keyword modifiers at far left of directory path search string were disabling directory search
· Ctrl+P in results list will now the original right-click properties menu for a file/folder (use CTRL+R for FARR context menu)
· Added new alternate alias action system!

Version 2.00.32 - January 15, 2007

· Bug fix - locales using , for floating point separation were zeroing out the scores when editing [thx hornsts]
· Fixed bug in command to remove folder entries from launch history.
· If search string ends in \ it now still matches against compatible folder names.
· Activating a folder name with an exact match to search string now opens it.

Version 2.00.26 - January 14, 2007

· Fixed bug in full path searching
· Removed unnesc. start menu items and changed startup entry name.
· Added help page summarizing hotkey shortcuts.
· Added results hotkey Ctrl+R to bring up right-click results context menu.
· Added "Export Formatted Alias Text" tool from options menu to make it easier to share aliases.

Version 2.00.25 - January 13, 2007

· You can now set a hotkey for each alias; pressing it will bring up FARR with the alias results shown (i.e. as a menu)

Version 2.00.24 - January 13, 2007

· Improved and clarified and took out of experimental stage the options for minimizing (or not) memory use on minimiztion.
· Added option to allow multiword search to apply to full paths even without \ path separators

Version 2.00.23 - January 12, 2007

· *ALL* words in a multiword search must be found or files will be rejected
· Multiple words containing * wildcards now work (but aren't normally needed)
· Changed behavior of search keyword modifiers; now if a modifier keyword is used, no entries with blank keyword modifiers will be included in the search. Only if the entry contains * will it be used on a search with all keywords. if you want to have an entry used both on blank search and on other keywords, use the keyword blank.
· Changed the option regarding history score sorting; you can now choose to display launch history on a blank search sorted by last use without regard to scores.
· New search history buffer (use Ctrl+Up and Ctrl+Down to scroll through).
· Non-contiguous search words now prefer words found in serial order.
· Directory searching without explicit paths now only matches keywords against file directory name.
· File extensions are now included in search comparisons
· Added ability to negate words to reject results containing them, just start word with -

Version 2.00.09 - January 7, 2007

· Fixed bug where if form was closed while options are open, the options dialog wont show from tray.
· Break key from options dialog now returns to main form.
· Keyword modifiers are now implemented(!)
· Multiple non-contiguous word search is now implemented (words separated by spaces will be found even if not contiguous)
· Fixed bug where options dialogs were sometimes appearing below others [thx jgpaiva]

Version 2.00.08 - January 4, 2007

· Fixed bug where ( and / stopped working
· Updaed the included FBSL (Freestyle Basic Script Language) calc.exe utility for providing calculator functionality.
· Reduced size of edit box and reverted to standard white background as per requests.
· Fixed bug where \ characters were disrupting alias results.
· Copy path to clipboard now copies the url location of .URL links.
· Simplified some context-menu captions [thanks masu].
· Added "JumpTo" context menu command to open file directory path in search edit box.
· Added new field %cliptext% that you can use for replacement in alias launching.
· Auto disable inappropriate context menu items on right-click.
· Updated the add pattern context menu rules for directories.
· Added ability to drag and drop files from outside farr onto farr (results, editbar, or tool panel).
· Minor update of built in alias list.

Version 2.00.06 - December 22, 2006

· Improved subtle appearance of forum in several respects.
· Larger font for edit box.
· Added new user-submitted icons and made tray icon user selectable.
· Filled in missing hints for many options.
· Improved menu icons.
· Upgraded to support more skin files.
· Hiding the status bar now works again.
· Removed the option to put the edit box at top - didn't work well.
· Tied history item scores are now properly sorted.
· Added option to quickly disable adaptive history use scoring.
· Changed behavior of right clicking on folders - now brings you back to edit box.
· You can now use ctrl+right arrow to jump to file's directory in search edit box.
· Added option to remove missing history items.
· You can now type just the drive letter follow by forwardslash, without the ':', for example: d\ for instead of D:\
· Minor tweaking of cursor/escape/tab key actions.
· Added option for tab used as autocomplete or normal.
· Added option to toggle column headers.
· Added option to skin the results window or not.

Version 2.00.04 - December 20, 2006

· Fixed bug where . was shown at end of filenames with no extensions and at end of directories, when result label option is on.
· Default is now to show extension in result labels.
· Added ability to go into and pop up out of directories while in the results panel using arrow keys LEFT and RIGHT.
· Updated icon.
· Tweaked dialogs a little to fix tab orders.
· Changed default folder heuristic score so that lnk shortcuts normally score higher.
· Fixed bug where backspace wasnt working right in search box, and ctrl+backspace.

Version 2.00.01 - December 19, 2006

· Added directory searching.
· Added ability to specify explicit paths in a search.
· Added keyboard hotkeys (alt+arrows, alt+enter, alt+backspace) to aid directory searching.
· Changed hotkey to launch all programs to be ctrl+alt+Enter (was ctrl+Enter)
· If a directory is marked with a -9999 score in search Pattern Scoring tab, it will skipped from searching (useful to avoid searching entire subdirectories).
· Added history execution incremental scoring, so the more an app is launched the higher it will rise in score to a max value (set in heuristics),
· Fixed bug where random icons are being displayed on alias groups.
· Added folder browse button to search pattern scoring entry dialog.
· No more annoying beeps when you press certain keys (alt, escape, etc.)
· When the digits are set to launch files directly, use the # character to escape the next digit
· Incorporated a feature that can quickly reject badly scoring items for faster searching.

Version 1.13.02 - Oct 10, 2006

· Fixed bug when activating FARR with "-standalone" commandline option, or showing via manual tray "restore from tray" menu item [thanks JanS].

Version 1.13.01 - Oct 08, 2006

· Hitting hotkey to switch to farr when its already visible but not focused will bring it to focus and no longer reset the search [requested by lanux and jgpaiva - http://www.donationcoder.com/Forums/bb/index.php?topic=5617]
· Improved startup speed and efficiency.

Version 1.11.01 - Oct 02, 2006

· Added option to try to keep program in memory for faster wakeup.
· Improved wakeup-search on alias, so it doesn't do further search in this case.
· Improved custom explorer/browser links to work even when there are spaces in path.
· Improved custom explorer/browser to allow custom launch strings with parameters.
· Improved (hopefully) some odd focus issues when working with options.
· Added Help item to tray menu.
· Attempting to improve catching of first key when window not yet visible.

Version 1.10.04 - Sep 19, 2006

· Fixed bug when . character was in alias name [thx lanux and bugtracker submitter].
· Alt+P from farr edit box now shows options.
· Confirmation is requested on deleting alias/scoring items.
· Fixed bug where using digit keys to launch on non-standard keyboards could result in superfluous searching.
· Added option to specify starting search text (useful for starting with an alias menu).
· Changed default startup mode to tray based (use -standalone) to exit immediately after display.
· Fixed bug in launching all results (Ctrl+Enter).
· First attempt to improve some inefficiencies in launch display speed and focus grabbing.
· Added experimental directory cacheing attempt (see General options) to reduce startup delay after long disuse.
· Fixed bug where $$1 arguments in regex alias groups were being forced to lowercase [thx perlguy]
· Fixed bug where custom file explorer was not being used to explore folders.

Version 1.09.05 - Mar 23, 2006

· Fixed bug where it was not saving the license key file (thanks to everyone on the forum for reporting this).

Version 1.09.04 - Mar 06, 2006

· Fixed bug that wasn't displaying all past history items on blank startup.
· Only keeps history of real files launched in the past (not aliases).
· Fixed bug when changing display options while skin activated

Version 1.09.02 - Mar 03, 2006

· Added a bunch of default aliases for internet searching, pasting common expressions, and more.
· Added the the FBSL calc exe and alias (thanks to the Freestyle Basic Script Language http://www.fbsl.net/phpbb2/index.php); see http://www.donationcoder.com/Forums/bb/index.php?topic=2344 for more informaiton.
· Fixed crashing bug with danish Jaws v6.0x screenreader (if anyone had any other odd shutdown crashes this might also fix)
· Ctrl+Space option for launching added
· Trying to remove the occasional "ding" sound on hitting enter to launch an application
· Option to launch programs with numpad keys
· All forms are skinned if skinning is enabled
· A skin is now configured as default.
· Options are saved on windows shutdown.
· Options button now directly opens options form (configure toolbar from that menu)
· Improved speed of startup and filechecking by limiting filechecking of initial history list.
· Added random startup statusbar hints
· Changed some of the default settings for new installations.

Version 1.07.21 - Oct 05, 2005

· changing position of edit box/statusbar now tries to fix up skinning without requiring a restart.

Version 1.07.20 - Oct 05, 2005

· statusbar now reports total search time after search finishes
· options to disable statusbar
· options to show editbox at bottom
· startup statusbar text now always shows welcome.

Version 1.07.19 - Oct 04, 2005

· mailto: containing spaces in subject fixed
· trying to fix lanux window sizing bug

Version 1.07.18 - Oct 02, 2005

· Preferences option in system tray icon.
· Changed wording of system tray icon exit option.
· CONTROL+Click of results now launches an app and STAYS open..
· When autosize window option and clear window options are checked, main window is now shrunk before restoring to avoid flicker.

Version 1.07.17 - Oct 02, 2005

· Autoshrink of window now reduced window size using a rapid timer to prevent flickering during incremental search.

Version 1.07.16 - Oct 02, 2005

· You can now type 'agroups' in the search edit box to get a list of all available group aliases
· Added new special command "alias" which can be used in a group alias entry to cause search to renew using the words following the alias. Useful to let one alias group to trigger further searches.

Version 1.07.15 - Oct 02, 2005

· Full skin selection plus ability to disable skinning
· Setting transparency to 0 now changes window mode to non-transparent (better for capturing screenshots of it)
· Reorganized some preference dialog pages.

Version 1.07.14 - Oct 02, 2005

· when remove-duplicates option was enabled, shortcuts which differ only in arguments are now treated as non-duplicates
· added auto-sizing window option (see config panel2 and disable "Blank search shows files from launch history" if you want smallest bar window on launch).
· preliminary test of skinning

Version 1.07.13 - Sep 23, 2005

· [bugfix] location path options were not working

Version 1.07.12 - Sep 23, 2005

· added paste command (can be used with alias group to paste text to previous app)

Version 1.07.11 - Sep 21, 2005

· Added import+export+paste of group aliases
· You can add - at start of any item in an alias group to disable it
· Reenbabled ins/del/edit keys in listviews

Version 1.07.10 - Sep 16, 2005

· [feature] Added environment variables in dir paths for search %USERPROFILE%, %USERNAME%, %ALLUSERSPROFILE%, %MYDOCUMENTS%, %MYFAVORITES%
· [bugfix] regex field replacement failed if two fields were directl adjacent, e.g. $$1$$2

Version 1.07.09 - Sep 10, 2005

· [feature] you could now be able to launch files that are in system path without specifying directory
· [bugfix] escaping digits \# was broken on last release
· [bugfix] regular expressions were not being saved the first time you created a particular alias group.

Version 1.07.07 - Sep 08, 2005

· Disabling launch with digits was also disableing all the alt,control modifiers (defeated the entire purpose!)

Version 1.07.03 - Sep 07, 2005

· adding some special variable for alias commands: %fardir% = find&run exe dir.

Version 1.07.02 - Sep 06, 2005

· Hotkey now restores focus rather than minimizes if pressed while in another window.
· Configuration backup files now saved.
· Configuration safety save - prevents corruption of configuration files if system crashes during save.
· Custom file explorer can be specified in options for launching folders (use \ at end of alias entry for folders).
· Added option for lanching first result on enter no matter what.
· You can now customize columns displayed in report view of results.
· Fixes Alt+# hotkey (show f&r right-click menu).

Version 1.07.01

· Full regular expression commands and arguments in alias groups
· Manually specified alias result descriptions (see alias edit dialog)
· Help file was sometimes not being shown when requested.

Version 1.06.02

· Added hotkeys for Ctrl+# (show shell context menu), Alt+# (show f&r right-click menu), Ctrl+Alt+# (launch and stay open)

Version 1.06.01

· Working directory (start in directory) of shortcuts was not being respected.
· Stop on exact alias match option was ignored, was always stopping.
· Alias results were not showing url contents properly
· Alias urls were not being launched properly
· Actual urls of shortcuts now shown in status bar when clicking on them
· Alias results "location" column now shows group name
· Unlimited alias group contents results now shown when an exact alias match is found.
· Added custom browser configuration option for launching shortcuts.
· Launched urls can now be added to history and scored appropriately.
· Last version was improperly focusing results window on startup.

Version 1.05.24, August 29, 2005

· added ability to drag files out of f&r window into other programs.
· added ability to drag and drop url links as urls.
· changed help/options button to icon toolbar
· added user-configurable toolbar items (and right-click option to add app to it)

Version 1.05.23, August 27, 2005

· fixed numerous minor form layout issues
· added file browse button to alias form.
· added properties menu item to right click
· changed from default of startmenu\program files to startmenu\

Version 1.05.22, August 27, 2005

· Added instructions about right-clicking in options tabs
· Added normal shell context menu pop-up
· Added "add to group" menu item for easy alias making
· Added scrollbars to alias listbox
· Added License key code
· Added alt+space hotkey
· bugfix - hotkeys weren't being set on startup
· bugfix - horizontal scrollbar was being shown on start

Version 1.05.19, July 24, 2005

· fixed bug with some win9x users where system shortcut hotkeys would be disabled
· config options being broken up into multiple tabs
· new options for custom hotkey and checkbox for pause/break key
· new options for focus-retaining function (this may be improved later)
· asks for confirmation before reseting all options from the menu
· better default settings on first use
· fixed messagebox bug where it was appearing under main window.

· Verion 1.05.16, June 02, 2005

cleaned help file a bit

added info about running main executable with -tray commandline option

fixed a failure to identify some duplicate links

added browse for file+folder buttons from the config add/edit entry dialogs.

removed menus to load and save configuration files (not it always use the main FindAndRunRobot.ini file.

program tries to grab focus back whenever it loses it.

attempt to fix issue with launching SFN versions of apps (ie opera problem).

fixed bug where it kept re-activating the start-with-windows switch (bug also could cause tiny slowdown on startup)

· Version 1.05.13, April 03, 2005

statusbar hint for "stop on exact alias match" was corrected; thanks mario_a from forum.

· Version 1.05.12, Match 31, 2005

strange ms office shortcuts were not launching properly (thx Alex for pointing this out)

· Version 1.05.11, Match 28, 2005

improved handling of .lnk files with arguments

· Version 1.05.10, Match 28, 2005

bugfix: typo in options dialog

bugfix: popup menu in heueristics scoring tab should not have presented add/delete options

modification: installer corrected to display DonationCoder.com info and "Super Happy" removed from program name.

· Version 1.05.09, Match 27, 2005

bugfix for error if launching an app while search still ongoing

· Version 1.05.08, Match 26, 2005

selecting an item in results window stops search

stated adding scripts feature - more scripts to come

· Version 1.05.07, March 25, 2005

Improved shortcut launching

Added new helper mini exe to circumvent weird windows ShellExecute delay on launching docs via ShellExecute()

Added code to not get confused by quick double hotkey activation that seems to occur from some apps (ms excel).

Alpha Blending options were causing complaints on win9x; this is now fixed, program works fine on win9x (though alpha blending has no effect of course).

· Version 1.05.04, March 25. 2005

Cursor arrows in and out of search box works better now.

Pressing down arrow during search stops search and moves cursor into results view.

Fixed bug with scrollbars on long listviews.

Slightly improved icon.

· Version 1.05.02, March 25. 2005

New window transparency control in options.

By default moves recent docs and desktop links to top of search list and enabled by default.

Added instrcutions in install to enable recent docs and move to top.

· Version 1.05.01, March 25. 2005

fixed bug that could result in program trying to save changed options more than necesary

changed default launch history to 50 items

fixed (maybe) gray empty header on launch in details mode with no items

fixed bug causing flash of previous items when clear on restart is checked

double click now toggles view when using fast style launcher

fixed bug where on trigger you would see previous find list first before it resets

adding exclusion rules for apps now adds these rules to pattern match box not history box, and removes any existing entry from history launch.

some apparent "hanging" of the program was due to obscured windows, hopefully fixed now.

adding an exclusion now forces score to -9999 even if a prior rule exists

· Version 1.04.08, Sep 26, 2003

Form now forces itself onto screen if it find itself offscreen.

· Version 1.04.07, Aug 22, 2003

Fixed bug where settings were not being saved on windows shutdown.

· Version 1.04.06, July 10, 2003

Added options to control whether to clear last search on reactivation.

Fixed bug from 1.04.05 that was disabling scoring.

· Version 1.04.05, July 10, 2003

The option to show history now always shows top history in order of most recent execution, ignoring scores.

Aliases matches now only count if they match the leftmost input string.

· Version 1.04.04, July 03, 2003

Added option to stop search when an exact alias match is found, and ctrl-enter to launch all found links, which together can be used to launch groups of applications.

· Version 1.04.03, July 03, 2003

Added "copy target path to clipboard" to context menu, with ctrl-c shortcut.

· Version 1.04.02, July 03, 2003

Slight bug was slowing down the user interface.

· Version 1.04.01, July 03, 2003

Fixed an isidious bug that was leaking file handles (leaving them open), which could result in wasted memory usage.

· Version 1.04.00, July 02, 2003

Major new option which allows you to select from two very different ways of configuring startup behavior.

· Version 1.03.02, May 16, 2003

Programs are now launched with their working directories set to the program's location, which is nesc. for some apps.

Added text in pattern scoring dialog to remind user they can use -9999 to block a pattern from showing.

· Version 1.03.01, May 15, 2003

Fixed a bug in the way shortcuts linking to same target app are handled - in prior versions it was possible for lower scoring duplicates to take the place of higher scoring ones.

New option for specifying whether low-scoring duplicates should be removed.

Moved to x.yy.zz version numbering.

You can now use \# to represent a digit in a filename even when you've got the "Digit Keys Launch Results" option checked.

Added right-click context menu item to 'remove this entry from launch history'.

Status bar now shows location of *linked* shortcut file, if main window shows shortcut path.

Added right-click context menu to 'add a rule to prevent this link from being found again'

· Version 1.2b8, Aug 22, 2002

added WinConsole to related apps list

· Version 1.2b7, April 25, 2002

when triggered program now grabs focus - nesc. on win2k to insure that the launched window does not lose focus because of some fluke

added ShellSearch to related apps list.

· Version 1.2b6, March 29, 2002

when you click on a found file result, status bar now shows full filename.

major feature added - new tab for aliases - you can add custom aliases for a single file or for groups of files

· Version 1.2b5, March 22, 2002

complete help file now provided

speedup in search routine

· Version 1.2b4, March 20, 2002

minor feature added - new option in right-click on results to open explorer at *linked* file location (location pointed to by shortcut).

minor feature added - new option in right-click on results to perform a one-time search of ALL matching results (rather than just the top x)

minor feature added - the statusbar now shows hints for all controls as you drag the mouse over them.

bugfix - dbl-clicking on entry in history window caused crash.

· Version 1.2b3, March 20, 2002

minor feature added - if a shortcut match is found, each pattern entry will get points if it matches either shortcut name or linked file name (so a shortcut pointing to an exe would get points for *.lnk and also *.exe).

minor feature added - function keys can now be used to select the item to launch (if you dont have these configured as hotkeys for other applications through OS global hotkeys).

feature added - from the File menu on Options dialog, you can now reset settings to defaults.

bugfix - duplicate file finder was completely rejecting non-shortcut files. oops.

bugfix - shortcuts to non-existent files were causing very long delays to resolve.

bugfix - disabling heuristic searches was not having any effect (they were always included in score).

· Version 1.2b2, March 20, 2002

bugfix - percent match scores now work properly when you use explicit wildcards in your search string.

· Version 1.2b1, March 20, 2002

feature added - now checks for duplicate references in shortcuts, etc. eliminates duplicate files shown.

· Version 1.1, March 19, 2002

minor feature added - if you use wildcards in your search string, the pattern will be used explicitly for searching; previously all searches were treated as *searchstring*.

· Version 1.0, March 18, 2002

First release

Thank You:

· Brad Stowers for his ItemProp unit to display context menu easily
· Only one instance at a time is allowed to run, thanks to Florian Bömers OneInst component.
· Troel Jakobson for his wonderful components - http://subsimple.com/delphi.asp